module.exports = {"id":"assets-spec","paths":{"relative":"assets-spec.md","project":"docs/assets-spec.md","projectRequire":"docs/assets-spec.md","absolute":"/Users/jonathan/Skypager/packages/skypager/test/fixture/docs/assets-spec.md"},"assetGroup":"documents","fingerprint":"02d8eba3a8793ff0e1292b3f4f313f14","markdown":"# Assets\n\nSkypager Projects consist of two types of files: `Assets` and `Helpers` \n\nAssets consist of content such as markdown writing, or files that contain data, code, or images.\n\nAssets which can be parsed can be used to generate data for the Project's entities.\n\n## Specifications\n\n### Skypager makes assets available through different collections\n\n```javascript\nproject.content.documents.assets.should.not.be.empty()\nproject.content.assets.assets.should.not.be.empty()\nproject.content.data_sources.assets.should.not.be.empty()\n```\n\n### Skypager treats svg assets as normal Assets\n\nSVG Assets can be embedded in rendered markdown documents by using a special embed syntax.\n\n```javascript\nproject.content.assets.at('example').uri.should.match(/example.svg/)\nproject.content.assets.at('example').should.have.property('assetType', 'asset')\n```\n\n### Skypager assets have a dedicated parser\n\n```javascript\nproject.content.documents.at('index').parser.should.be.a.Function\n```\n\n### Skypager treats markdown as Document assets\n\n```javascript\nproject.content.documents.at('index').should.have.property('assetType', 'document')\nproject.content.documents.at('index').should.have.property('parser')\n```\n\n### Skypager treats JSON as parseable DataSource assets \n\n```javascript\nproject.content.data_sources.at('example').should.have.property('assetType', 'DataSource')\nproject.content.data_sources.at('example').should.have.property('parser')\n```\n\n### Skypager treats YAML as parseable DataSource assets \n\n```javascript\nproject.content.data_sources.at('inspiration').should.have.property('assetType', 'DataSource')\nproject.content.data_sources.at('inspiration').should.have.property('parser')\n```\n\n### Skypager treats CSV as parseable DataSource assets \n\n```javascript\nproject.content.data_sources.at('tabular').should.have.property('assetType', 'DataSource')\nproject.content.data_sources.at('tabular').should.have.property('parser')\n```\n\n### Skypager treats Javascript as parseable DataSource assets \n\n```javascript\nproject.content.data_sources.at('community-plugins').should.have.property('assetType', 'DataSource')\nproject.content.data_sources.at('community-plugins').should.have.property('parser')\n```\n","ast":{"type":"root","children":[{"type":"heading","depth":1,"children":[{"type":"text","value":"Assets","position":{"start":{"line":1,"column":3},"end":{"line":1,"column":9},"indent":[]}}],"position":{"start":{"line":1,"column":1},"end":{"line":1,"column":9},"indent":[]},"index":0,"data":{"htmlAttributes":{"id":"assets","data-node-index":0}},"id":"assets","value":"Assets","parentId":"assets-spec"},{"type":"paragraph","children":[{"type":"text","value":"Skypager Projects consist of two types of files: ","position":{"start":{"line":3,"column":1},"end":{"line":3,"column":50},"indent":[]}},{"type":"inlineCode","value":"Assets","position":{"start":{"line":3,"column":50},"end":{"line":3,"column":58},"indent":[]}},{"type":"text","value":" and ","position":{"start":{"line":3,"column":58},"end":{"line":3,"column":63},"indent":[]}},{"type":"inlineCode","value":"Helpers","position":{"start":{"line":3,"column":63},"end":{"line":3,"column":72},"indent":[]}},{"type":"text","value":" ","position":{"start":{"line":3,"column":72},"end":{"line":3,"column":73},"indent":[]}}],"position":{"start":{"line":3,"column":1},"end":{"line":3,"column":73},"indent":[]},"index":1,"depth":1,"parentId":"assets","childIndex":0,"childId":"p-1-1","id":"assets-p-1-1","data":{"htmlAttributes":{"data-node-index":1}}},{"type":"paragraph","children":[{"type":"text","value":"Assets consist of content such as markdown writing, or files that contain data, code, or images.","position":{"start":{"line":5,"column":1},"end":{"line":5,"column":97},"indent":[]}}],"position":{"start":{"line":5,"column":1},"end":{"line":5,"column":97},"indent":[]},"index":2,"depth":1,"parentId":"assets","childIndex":1,"childId":"p-1-2","id":"assets-p-1-2","data":{"htmlAttributes":{"data-node-index":2}}},{"type":"paragraph","children":[{"type":"text","value":"Assets which can be parsed can be used to generate data for the Project's entities.","position":{"start":{"line":7,"column":1},"end":{"line":7,"column":84},"indent":[]}}],"position":{"start":{"line":7,"column":1},"end":{"line":7,"column":84},"indent":[]},"index":3,"depth":1,"parentId":"assets","childIndex":2,"childId":"p-1-3","id":"assets-p-1-3","data":{"htmlAttributes":{"data-node-index":3}}},{"type":"section","depth":2,"children":[{"type":"heading","depth":2,"children":[{"type":"text","value":"Specifications","position":{"start":{"line":9,"column":4},"end":{"line":9,"column":18},"indent":[]}}],"position":{"start":{"line":9,"column":1},"end":{"line":9,"column":18},"indent":[]},"index":4,"data":{"htmlAttributes":{"id":"specifications"}},"id":"specifications","value":"Specifications","parentId":"assets"},{"type":"article","depth":3,"children":[{"type":"heading","depth":3,"children":[{"type":"text","value":"Skypager makes assets available through different collections","position":{"start":{"line":11,"column":5},"end":{"line":11,"column":66},"indent":[]}}],"position":{"start":{"line":11,"column":1},"end":{"line":11,"column":66},"indent":[]},"index":5,"data":{"htmlAttributes":{"id":"skypager-makes-assets-available-through-different-collections"}},"id":"skypager-makes-assets-available-through-different-collections","value":"Skypager makes assets available through different collections","parentId":"specifications"},{"type":"code","lang":"javascript","value":"project.content.documents.assets.should.not.be.empty()\nproject.content.assets.assets.should.not.be.empty()\nproject.content.data_sources.assets.should.not.be.empty()","position":{"start":{"line":13,"column":1},"end":{"line":17,"column":4},"indent":[1,1,1,1]},"index":6,"depth":3,"parentId":"skypager-makes-assets-available-through-different-collections","childIndex":0,"childId":"code-3-1","id":"skypager-makes-assets-available-through-different-collections-code-3-1","data":{"htmlAttributes":{"data-node-index":6}}}],"position":{"start":{"line":11,"column":1},"end":{"line":11,"column":66},"indent":[]},"index":5,"data":{"htmlName":"article","htmlAttributes":{"class":"depth-3 articles","id":"skypager-makes-assets-available-through-different-collections","data-node-index":5}},"id":"skypager-makes-assets-available-through-different-collections","value":"Skypager makes assets available through different collections","parentId":"specifications"},{"type":"article","depth":3,"children":[{"type":"heading","depth":3,"children":[{"type":"text","value":"Skypager treats svg assets as normal Assets","position":{"start":{"line":19,"column":5},"end":{"line":19,"column":48},"indent":[]}}],"position":{"start":{"line":19,"column":1},"end":{"line":19,"column":48},"indent":[]},"index":7,"data":{"htmlAttributes":{"id":"skypager-treats-svg-assets-as-normal-assets"}},"id":"skypager-treats-svg-assets-as-normal-assets","value":"Skypager treats svg assets as normal Assets","parentId":"specifications"},{"type":"paragraph","children":[{"type":"text","value":"SVG Assets can be embedded in rendered markdown documents by using a special embed syntax.","position":{"start":{"line":21,"column":1},"end":{"line":21,"column":91},"indent":[]}}],"position":{"start":{"line":21,"column":1},"end":{"line":21,"column":91},"indent":[]},"index":8,"depth":3,"parentId":"skypager-treats-svg-assets-as-normal-assets","childIndex":0,"childId":"p-3-1","id":"skypager-treats-svg-assets-as-normal-assets-p-3-1","data":{"htmlAttributes":{"data-node-index":8}}},{"type":"code","lang":"javascript","value":"project.content.assets.at('example').uri.should.match(/example.svg/)\nproject.content.assets.at('example').should.have.property('assetType', 'asset')","position":{"start":{"line":23,"column":1},"end":{"line":26,"column":4},"indent":[1,1,1]},"index":9,"depth":3,"parentId":"skypager-treats-svg-assets-as-normal-assets","childIndex":1,"childId":"code-3-2","id":"skypager-treats-svg-assets-as-normal-assets-code-3-2","data":{"htmlAttributes":{"data-node-index":9}}}],"position":{"start":{"line":19,"column":1},"end":{"line":19,"column":48},"indent":[]},"index":7,"data":{"htmlName":"article","htmlAttributes":{"class":"depth-3 articles","id":"skypager-treats-svg-assets-as-normal-assets","data-node-index":7}},"id":"skypager-treats-svg-assets-as-normal-assets","value":"Skypager treats svg assets as normal Assets","parentId":"specifications"},{"type":"article","depth":3,"children":[{"type":"heading","depth":3,"children":[{"type":"text","value":"Skypager assets have a dedicated parser","position":{"start":{"line":28,"column":5},"end":{"line":28,"column":44},"indent":[]}}],"position":{"start":{"line":28,"column":1},"end":{"line":28,"column":44},"indent":[]},"index":10,"data":{"htmlAttributes":{"id":"skypager-assets-have-a-dedicated-parser"}},"id":"skypager-assets-have-a-dedicated-parser","value":"Skypager assets have a dedicated parser","parentId":"specifications"},{"type":"code","lang":"javascript","value":"project.content.documents.at('index').parser.should.be.a.Function","position":{"start":{"line":30,"column":1},"end":{"line":32,"column":4},"indent":[1,1]},"index":11,"depth":3,"parentId":"skypager-assets-have-a-dedicated-parser","childIndex":0,"childId":"code-3-1","id":"skypager-assets-have-a-dedicated-parser-code-3-1","data":{"htmlAttributes":{"data-node-index":11}}}],"position":{"start":{"line":28,"column":1},"end":{"line":28,"column":44},"indent":[]},"index":10,"data":{"htmlName":"article","htmlAttributes":{"class":"depth-3 articles","id":"skypager-assets-have-a-dedicated-parser","data-node-index":10}},"id":"skypager-assets-have-a-dedicated-parser","value":"Skypager assets have a dedicated parser","parentId":"specifications"},{"type":"article","depth":3,"children":[{"type":"heading","depth":3,"children":[{"type":"text","value":"Skypager treats markdown as Document assets","position":{"start":{"line":34,"column":5},"end":{"line":34,"column":48},"indent":[]}}],"position":{"start":{"line":34,"column":1},"end":{"line":34,"column":48},"indent":[]},"index":12,"data":{"htmlAttributes":{"id":"skypager-treats-markdown-as-document-assets"}},"id":"skypager-treats-markdown-as-document-assets","value":"Skypager treats markdown as Document assets","parentId":"specifications"},{"type":"code","lang":"javascript","value":"project.content.documents.at('index').should.have.property('assetType', 'document')\nproject.content.documents.at('index').should.have.property('parser')","position":{"start":{"line":36,"column":1},"end":{"line":39,"column":4},"indent":[1,1,1]},"index":13,"depth":3,"parentId":"skypager-treats-markdown-as-document-assets","childIndex":0,"childId":"code-3-1","id":"skypager-treats-markdown-as-document-assets-code-3-1","data":{"htmlAttributes":{"data-node-index":13}}}],"position":{"start":{"line":34,"column":1},"end":{"line":34,"column":48},"indent":[]},"index":12,"data":{"htmlName":"article","htmlAttributes":{"class":"depth-3 articles","id":"skypager-treats-markdown-as-document-assets","data-node-index":12}},"id":"skypager-treats-markdown-as-document-assets","value":"Skypager treats markdown as Document assets","parentId":"specifications"},{"type":"article","depth":3,"children":[{"type":"heading","depth":3,"children":[{"type":"text","value":"Skypager treats JSON as parseable DataSource assets","position":{"start":{"line":41,"column":5},"end":{"line":41,"column":56},"indent":[]}}],"position":{"start":{"line":41,"column":1},"end":{"line":41,"column":57},"indent":[]},"index":14,"data":{"htmlAttributes":{"id":"skypager-treats-json-as-parseable-datasource-assets"}},"id":"skypager-treats-json-as-parseable-datasource-assets","value":"Skypager treats JSON as parseable DataSource assets","parentId":"specifications"},{"type":"code","lang":"javascript","value":"project.content.data_sources.at('example').should.have.property('assetType', 'DataSource')\nproject.content.data_sources.at('example').should.have.property('parser')","position":{"start":{"line":43,"column":1},"end":{"line":46,"column":4},"indent":[1,1,1]},"index":15,"depth":3,"parentId":"skypager-treats-json-as-parseable-datasource-assets","childIndex":0,"childId":"code-3-1","id":"skypager-treats-json-as-parseable-datasource-assets-code-3-1","data":{"htmlAttributes":{"data-node-index":15}}}],"position":{"start":{"line":41,"column":1},"end":{"line":41,"column":57},"indent":[]},"index":14,"data":{"htmlName":"article","htmlAttributes":{"class":"depth-3 articles","id":"skypager-treats-json-as-parseable-datasource-assets","data-node-index":14}},"id":"skypager-treats-json-as-parseable-datasource-assets","value":"Skypager treats JSON as parseable DataSource assets","parentId":"specifications"},{"type":"article","depth":3,"children":[{"type":"heading","depth":3,"children":[{"type":"text","value":"Skypager treats YAML as parseable DataSource assets","position":{"start":{"line":48,"column":5},"end":{"line":48,"column":56},"indent":[]}}],"position":{"start":{"line":48,"column":1},"end":{"line":48,"column":57},"indent":[]},"index":16,"data":{"htmlAttributes":{"id":"skypager-treats-yaml-as-parseable-datasource-assets"}},"id":"skypager-treats-yaml-as-parseable-datasource-assets","value":"Skypager treats YAML as parseable DataSource assets","parentId":"specifications"},{"type":"code","lang":"javascript","value":"project.content.data_sources.at('inspiration').should.have.property('assetType', 'DataSource')\nproject.content.data_sources.at('inspiration').should.have.property('parser')","position":{"start":{"line":50,"column":1},"end":{"line":53,"column":4},"indent":[1,1,1]},"index":17,"depth":3,"parentId":"skypager-treats-yaml-as-parseable-datasource-assets","childIndex":0,"childId":"code-3-1","id":"skypager-treats-yaml-as-parseable-datasource-assets-code-3-1","data":{"htmlAttributes":{"data-node-index":17}}}],"position":{"start":{"line":48,"column":1},"end":{"line":48,"column":57},"indent":[]},"index":16,"data":{"htmlName":"article","htmlAttributes":{"class":"depth-3 articles","id":"skypager-treats-yaml-as-parseable-datasource-assets","data-node-index":16}},"id":"skypager-treats-yaml-as-parseable-datasource-assets","value":"Skypager treats YAML as parseable DataSource assets","parentId":"specifications"},{"type":"article","depth":3,"children":[{"type":"heading","depth":3,"children":[{"type":"text","value":"Skypager treats CSV as parseable DataSource assets","position":{"start":{"line":55,"column":5},"end":{"line":55,"column":55},"indent":[]}}],"position":{"start":{"line":55,"column":1},"end":{"line":55,"column":56},"indent":[]},"index":18,"data":{"htmlAttributes":{"id":"skypager-treats-csv-as-parseable-datasource-assets"}},"id":"skypager-treats-csv-as-parseable-datasource-assets","value":"Skypager treats CSV as parseable DataSource assets","parentId":"specifications"},{"type":"code","lang":"javascript","value":"project.content.data_sources.at('tabular').should.have.property('assetType', 'DataSource')\nproject.content.data_sources.at('tabular').should.have.property('parser')","position":{"start":{"line":57,"column":1},"end":{"line":60,"column":4},"indent":[1,1,1]},"index":19,"depth":3,"parentId":"skypager-treats-csv-as-parseable-datasource-assets","childIndex":0,"childId":"code-3-1","id":"skypager-treats-csv-as-parseable-datasource-assets-code-3-1","data":{"htmlAttributes":{"data-node-index":19}}}],"position":{"start":{"line":55,"column":1},"end":{"line":55,"column":56},"indent":[]},"index":18,"data":{"htmlName":"article","htmlAttributes":{"class":"depth-3 articles","id":"skypager-treats-csv-as-parseable-datasource-assets","data-node-index":18}},"id":"skypager-treats-csv-as-parseable-datasource-assets","value":"Skypager treats CSV as parseable DataSource assets","parentId":"specifications"},{"type":"article","depth":3,"children":[{"type":"heading","depth":3,"children":[{"type":"text","value":"Skypager treats Javascript as parseable DataSource assets","position":{"start":{"line":62,"column":5},"end":{"line":62,"column":62},"indent":[]}}],"position":{"start":{"line":62,"column":1},"end":{"line":62,"column":63},"indent":[]},"index":20,"data":{"htmlAttributes":{"id":"skypager-treats-javascript-as-parseable-datasource-assets"}},"id":"skypager-treats-javascript-as-parseable-datasource-assets","value":"Skypager treats Javascript as parseable DataSource assets","parentId":"specifications"},{"type":"code","lang":"javascript","value":"project.content.data_sources.at('community-plugins').should.have.property('assetType', 'DataSource')\nproject.content.data_sources.at('community-plugins').should.have.property('parser')","position":{"start":{"line":64,"column":1},"end":{"line":67,"column":4},"indent":[1,1,1]},"index":21,"depth":3,"parentId":"skypager-treats-javascript-as-parseable-datasource-assets","childIndex":0,"childId":"code-3-1","id":"skypager-treats-javascript-as-parseable-datasource-assets-code-3-1","data":{"htmlAttributes":{"data-node-index":21}}}],"position":{"start":{"line":62,"column":1},"end":{"line":62,"column":63},"indent":[]},"index":20,"data":{"htmlName":"article","htmlAttributes":{"class":"depth-3 articles","id":"skypager-treats-javascript-as-parseable-datasource-assets","data-node-index":20}},"id":"skypager-treats-javascript-as-parseable-datasource-assets","value":"Skypager treats Javascript as parseable DataSource assets","parentId":"specifications"}],"position":{"start":{"line":9,"column":1},"end":{"line":9,"column":18},"indent":[]},"index":4,"data":{"htmlName":"section","htmlAttributes":{"class":"depth-2 sections","id":"specifications","data-node-index":4}},"id":"specifications","value":"Specifications","parentId":"assets"},{"type":"article","depth":3,"children":[{"type":"heading","depth":3,"children":[{"type":"text","value":"Skypager makes assets available through different collections","position":{"start":{"line":11,"column":5},"end":{"line":11,"column":66},"indent":[]}}],"position":{"start":{"line":11,"column":1},"end":{"line":11,"column":66},"indent":[]},"index":5,"data":{"htmlAttributes":{"id":"skypager-makes-assets-available-through-different-collections"}},"id":"skypager-makes-assets-available-through-different-collections","value":"Skypager makes assets available through different collections","parentId":"specifications"},{"type":"code","lang":"javascript","value":"project.content.documents.assets.should.not.be.empty()\nproject.content.assets.assets.should.not.be.empty()\nproject.content.data_sources.assets.should.not.be.empty()","position":{"start":{"line":13,"column":1},"end":{"line":17,"column":4},"indent":[1,1,1,1]},"index":6,"depth":3,"parentId":"skypager-makes-assets-available-through-different-collections","childIndex":0,"childId":"code-3-1","id":"skypager-makes-assets-available-through-different-collections-code-3-1","data":{"htmlAttributes":{"data-node-index":6}}}],"position":{"start":{"line":11,"column":1},"end":{"line":11,"column":66},"indent":[]},"index":5,"data":{"htmlName":"article","htmlAttributes":{"class":"depth-3 articles","id":"skypager-makes-assets-available-through-different-collections","data-node-index":5}},"id":"skypager-makes-assets-available-through-different-collections","value":"Skypager makes assets available through different collections","parentId":"specifications"},{"type":"code","lang":"javascript","value":"project.content.documents.assets.should.not.be.empty()\nproject.content.assets.assets.should.not.be.empty()\nproject.content.data_sources.assets.should.not.be.empty()","position":{"start":{"line":13,"column":1},"end":{"line":17,"column":4},"indent":[1,1,1,1]},"index":6,"depth":3,"parentId":"skypager-makes-assets-available-through-different-collections","childIndex":0,"childId":"code-3-1","id":"skypager-makes-assets-available-through-different-collections-code-3-1","data":{"htmlAttributes":{"data-node-index":6}}},{"type":"article","depth":3,"children":[{"type":"heading","depth":3,"children":[{"type":"text","value":"Skypager treats svg assets as normal Assets","position":{"start":{"line":19,"column":5},"end":{"line":19,"column":48},"indent":[]}}],"position":{"start":{"line":19,"column":1},"end":{"line":19,"column":48},"indent":[]},"index":7,"data":{"htmlAttributes":{"id":"skypager-treats-svg-assets-as-normal-assets"}},"id":"skypager-treats-svg-assets-as-normal-assets","value":"Skypager treats svg assets as normal Assets","parentId":"specifications"},{"type":"paragraph","children":[{"type":"text","value":"SVG Assets can be embedded in rendered markdown documents by using a special embed syntax.","position":{"start":{"line":21,"column":1},"end":{"line":21,"column":91},"indent":[]}}],"position":{"start":{"line":21,"column":1},"end":{"line":21,"column":91},"indent":[]},"index":8,"depth":3,"parentId":"skypager-treats-svg-assets-as-normal-assets","childIndex":0,"childId":"p-3-1","id":"skypager-treats-svg-assets-as-normal-assets-p-3-1","data":{"htmlAttributes":{"data-node-index":8}}},{"type":"code","lang":"javascript","value":"project.content.assets.at('example').uri.should.match(/example.svg/)\nproject.content.assets.at('example').should.have.property('assetType', 'asset')","position":{"start":{"line":23,"column":1},"end":{"line":26,"column":4},"indent":[1,1,1]},"index":9,"depth":3,"parentId":"skypager-treats-svg-assets-as-normal-assets","childIndex":1,"childId":"code-3-2","id":"skypager-treats-svg-assets-as-normal-assets-code-3-2","data":{"htmlAttributes":{"data-node-index":9}}}],"position":{"start":{"line":19,"column":1},"end":{"line":19,"column":48},"indent":[]},"index":7,"data":{"htmlName":"article","htmlAttributes":{"class":"depth-3 articles","id":"skypager-treats-svg-assets-as-normal-assets","data-node-index":7}},"id":"skypager-treats-svg-assets-as-normal-assets","value":"Skypager treats svg assets as normal Assets","parentId":"specifications"},{"type":"paragraph","children":[{"type":"text","value":"SVG Assets can be embedded in rendered markdown documents by using a special embed syntax.","position":{"start":{"line":21,"column":1},"end":{"line":21,"column":91},"indent":[]}}],"position":{"start":{"line":21,"column":1},"end":{"line":21,"column":91},"indent":[]},"index":8,"depth":3,"parentId":"skypager-treats-svg-assets-as-normal-assets","childIndex":0,"childId":"p-3-1","id":"skypager-treats-svg-assets-as-normal-assets-p-3-1","data":{"htmlAttributes":{"data-node-index":8}}},{"type":"code","lang":"javascript","value":"project.content.assets.at('example').uri.should.match(/example.svg/)\nproject.content.assets.at('example').should.have.property('assetType', 'asset')","position":{"start":{"line":23,"column":1},"end":{"line":26,"column":4},"indent":[1,1,1]},"index":9,"depth":3,"parentId":"skypager-treats-svg-assets-as-normal-assets","childIndex":1,"childId":"code-3-2","id":"skypager-treats-svg-assets-as-normal-assets-code-3-2","data":{"htmlAttributes":{"data-node-index":9}}},{"type":"article","depth":3,"children":[{"type":"heading","depth":3,"children":[{"type":"text","value":"Skypager assets have a dedicated parser","position":{"start":{"line":28,"column":5},"end":{"line":28,"column":44},"indent":[]}}],"position":{"start":{"line":28,"column":1},"end":{"line":28,"column":44},"indent":[]},"index":10,"data":{"htmlAttributes":{"id":"skypager-assets-have-a-dedicated-parser"}},"id":"skypager-assets-have-a-dedicated-parser","value":"Skypager assets have a dedicated parser","parentId":"specifications"},{"type":"code","lang":"javascript","value":"project.content.documents.at('index').parser.should.be.a.Function","position":{"start":{"line":30,"column":1},"end":{"line":32,"column":4},"indent":[1,1]},"index":11,"depth":3,"parentId":"skypager-assets-have-a-dedicated-parser","childIndex":0,"childId":"code-3-1","id":"skypager-assets-have-a-dedicated-parser-code-3-1","data":{"htmlAttributes":{"data-node-index":11}}}],"position":{"start":{"line":28,"column":1},"end":{"line":28,"column":44},"indent":[]},"index":10,"data":{"htmlName":"article","htmlAttributes":{"class":"depth-3 articles","id":"skypager-assets-have-a-dedicated-parser","data-node-index":10}},"id":"skypager-assets-have-a-dedicated-parser","value":"Skypager assets have a dedicated parser","parentId":"specifications"},{"type":"code","lang":"javascript","value":"project.content.documents.at('index').parser.should.be.a.Function","position":{"start":{"line":30,"column":1},"end":{"line":32,"column":4},"indent":[1,1]},"index":11,"depth":3,"parentId":"skypager-assets-have-a-dedicated-parser","childIndex":0,"childId":"code-3-1","id":"skypager-assets-have-a-dedicated-parser-code-3-1","data":{"htmlAttributes":{"data-node-index":11}}},{"type":"article","depth":3,"children":[{"type":"heading","depth":3,"children":[{"type":"text","value":"Skypager treats markdown as Document assets","position":{"start":{"line":34,"column":5},"end":{"line":34,"column":48},"indent":[]}}],"position":{"start":{"line":34,"column":1},"end":{"line":34,"column":48},"indent":[]},"index":12,"data":{"htmlAttributes":{"id":"skypager-treats-markdown-as-document-assets"}},"id":"skypager-treats-markdown-as-document-assets","value":"Skypager treats markdown as Document assets","parentId":"specifications"},{"type":"code","lang":"javascript","value":"project.content.documents.at('index').should.have.property('assetType', 'document')\nproject.content.documents.at('index').should.have.property('parser')","position":{"start":{"line":36,"column":1},"end":{"line":39,"column":4},"indent":[1,1,1]},"index":13,"depth":3,"parentId":"skypager-treats-markdown-as-document-assets","childIndex":0,"childId":"code-3-1","id":"skypager-treats-markdown-as-document-assets-code-3-1","data":{"htmlAttributes":{"data-node-index":13}}}],"position":{"start":{"line":34,"column":1},"end":{"line":34,"column":48},"indent":[]},"index":12,"data":{"htmlName":"article","htmlAttributes":{"class":"depth-3 articles","id":"skypager-treats-markdown-as-document-assets","data-node-index":12}},"id":"skypager-treats-markdown-as-document-assets","value":"Skypager treats markdown as Document assets","parentId":"specifications"},{"type":"code","lang":"javascript","value":"project.content.documents.at('index').should.have.property('assetType', 'document')\nproject.content.documents.at('index').should.have.property('parser')","position":{"start":{"line":36,"column":1},"end":{"line":39,"column":4},"indent":[1,1,1]},"index":13,"depth":3,"parentId":"skypager-treats-markdown-as-document-assets","childIndex":0,"childId":"code-3-1","id":"skypager-treats-markdown-as-document-assets-code-3-1","data":{"htmlAttributes":{"data-node-index":13}}},{"type":"article","depth":3,"children":[{"type":"heading","depth":3,"children":[{"type":"text","value":"Skypager treats JSON as parseable DataSource assets","position":{"start":{"line":41,"column":5},"end":{"line":41,"column":56},"indent":[]}}],"position":{"start":{"line":41,"column":1},"end":{"line":41,"column":57},"indent":[]},"index":14,"data":{"htmlAttributes":{"id":"skypager-treats-json-as-parseable-datasource-assets"}},"id":"skypager-treats-json-as-parseable-datasource-assets","value":"Skypager treats JSON as parseable DataSource assets","parentId":"specifications"},{"type":"code","lang":"javascript","value":"project.content.data_sources.at('example').should.have.property('assetType', 'DataSource')\nproject.content.data_sources.at('example').should.have.property('parser')","position":{"start":{"line":43,"column":1},"end":{"line":46,"column":4},"indent":[1,1,1]},"index":15,"depth":3,"parentId":"skypager-treats-json-as-parseable-datasource-assets","childIndex":0,"childId":"code-3-1","id":"skypager-treats-json-as-parseable-datasource-assets-code-3-1","data":{"htmlAttributes":{"data-node-index":15}}}],"position":{"start":{"line":41,"column":1},"end":{"line":41,"column":57},"indent":[]},"index":14,"data":{"htmlName":"article","htmlAttributes":{"class":"depth-3 articles","id":"skypager-treats-json-as-parseable-datasource-assets","data-node-index":14}},"id":"skypager-treats-json-as-parseable-datasource-assets","value":"Skypager treats JSON as parseable DataSource assets","parentId":"specifications"},{"type":"code","lang":"javascript","value":"project.content.data_sources.at('example').should.have.property('assetType', 'DataSource')\nproject.content.data_sources.at('example').should.have.property('parser')","position":{"start":{"line":43,"column":1},"end":{"line":46,"column":4},"indent":[1,1,1]},"index":15,"depth":3,"parentId":"skypager-treats-json-as-parseable-datasource-assets","childIndex":0,"childId":"code-3-1","id":"skypager-treats-json-as-parseable-datasource-assets-code-3-1","data":{"htmlAttributes":{"data-node-index":15}}},{"type":"article","depth":3,"children":[{"type":"heading","depth":3,"children":[{"type":"text","value":"Skypager treats YAML as parseable DataSource assets","position":{"start":{"line":48,"column":5},"end":{"line":48,"column":56},"indent":[]}}],"position":{"start":{"line":48,"column":1},"end":{"line":48,"column":57},"indent":[]},"index":16,"data":{"htmlAttributes":{"id":"skypager-treats-yaml-as-parseable-datasource-assets"}},"id":"skypager-treats-yaml-as-parseable-datasource-assets","value":"Skypager treats YAML as parseable DataSource assets","parentId":"specifications"},{"type":"code","lang":"javascript","value":"project.content.data_sources.at('inspiration').should.have.property('assetType', 'DataSource')\nproject.content.data_sources.at('inspiration').should.have.property('parser')","position":{"start":{"line":50,"column":1},"end":{"line":53,"column":4},"indent":[1,1,1]},"index":17,"depth":3,"parentId":"skypager-treats-yaml-as-parseable-datasource-assets","childIndex":0,"childId":"code-3-1","id":"skypager-treats-yaml-as-parseable-datasource-assets-code-3-1","data":{"htmlAttributes":{"data-node-index":17}}}],"position":{"start":{"line":48,"column":1},"end":{"line":48,"column":57},"indent":[]},"index":16,"data":{"htmlName":"article","htmlAttributes":{"class":"depth-3 articles","id":"skypager-treats-yaml-as-parseable-datasource-assets","data-node-index":16}},"id":"skypager-treats-yaml-as-parseable-datasource-assets","value":"Skypager treats YAML as parseable DataSource assets","parentId":"specifications"},{"type":"code","lang":"javascript","value":"project.content.data_sources.at('inspiration').should.have.property('assetType', 'DataSource')\nproject.content.data_sources.at('inspiration').should.have.property('parser')","position":{"start":{"line":50,"column":1},"end":{"line":53,"column":4},"indent":[1,1,1]},"index":17,"depth":3,"parentId":"skypager-treats-yaml-as-parseable-datasource-assets","childIndex":0,"childId":"code-3-1","id":"skypager-treats-yaml-as-parseable-datasource-assets-code-3-1","data":{"htmlAttributes":{"data-node-index":17}}},{"type":"article","depth":3,"children":[{"type":"heading","depth":3,"children":[{"type":"text","value":"Skypager treats CSV as parseable DataSource assets","position":{"start":{"line":55,"column":5},"end":{"line":55,"column":55},"indent":[]}}],"position":{"start":{"line":55,"column":1},"end":{"line":55,"column":56},"indent":[]},"index":18,"data":{"htmlAttributes":{"id":"skypager-treats-csv-as-parseable-datasource-assets"}},"id":"skypager-treats-csv-as-parseable-datasource-assets","value":"Skypager treats CSV as parseable DataSource assets","parentId":"specifications"},{"type":"code","lang":"javascript","value":"project.content.data_sources.at('tabular').should.have.property('assetType', 'DataSource')\nproject.content.data_sources.at('tabular').should.have.property('parser')","position":{"start":{"line":57,"column":1},"end":{"line":60,"column":4},"indent":[1,1,1]},"index":19,"depth":3,"parentId":"skypager-treats-csv-as-parseable-datasource-assets","childIndex":0,"childId":"code-3-1","id":"skypager-treats-csv-as-parseable-datasource-assets-code-3-1","data":{"htmlAttributes":{"data-node-index":19}}}],"position":{"start":{"line":55,"column":1},"end":{"line":55,"column":56},"indent":[]},"index":18,"data":{"htmlName":"article","htmlAttributes":{"class":"depth-3 articles","id":"skypager-treats-csv-as-parseable-datasource-assets","data-node-index":18}},"id":"skypager-treats-csv-as-parseable-datasource-assets","value":"Skypager treats CSV as parseable DataSource assets","parentId":"specifications"},{"type":"code","lang":"javascript","value":"project.content.data_sources.at('tabular').should.have.property('assetType', 'DataSource')\nproject.content.data_sources.at('tabular').should.have.property('parser')","position":{"start":{"line":57,"column":1},"end":{"line":60,"column":4},"indent":[1,1,1]},"index":19,"depth":3,"parentId":"skypager-treats-csv-as-parseable-datasource-assets","childIndex":0,"childId":"code-3-1","id":"skypager-treats-csv-as-parseable-datasource-assets-code-3-1","data":{"htmlAttributes":{"data-node-index":19}}},{"type":"article","depth":3,"children":[{"type":"heading","depth":3,"children":[{"type":"text","value":"Skypager treats Javascript as parseable DataSource assets","position":{"start":{"line":62,"column":5},"end":{"line":62,"column":62},"indent":[]}}],"position":{"start":{"line":62,"column":1},"end":{"line":62,"column":63},"indent":[]},"index":20,"data":{"htmlAttributes":{"id":"skypager-treats-javascript-as-parseable-datasource-assets"}},"id":"skypager-treats-javascript-as-parseable-datasource-assets","value":"Skypager treats Javascript as parseable DataSource assets","parentId":"specifications"},{"type":"code","lang":"javascript","value":"project.content.data_sources.at('community-plugins').should.have.property('assetType', 'DataSource')\nproject.content.data_sources.at('community-plugins').should.have.property('parser')","position":{"start":{"line":64,"column":1},"end":{"line":67,"column":4},"indent":[1,1,1]},"index":21,"depth":3,"parentId":"skypager-treats-javascript-as-parseable-datasource-assets","childIndex":0,"childId":"code-3-1","id":"skypager-treats-javascript-as-parseable-datasource-assets-code-3-1","data":{"htmlAttributes":{"data-node-index":21}}}],"position":{"start":{"line":62,"column":1},"end":{"line":62,"column":63},"indent":[]},"index":20,"data":{"htmlName":"article","htmlAttributes":{"class":"depth-3 articles","id":"skypager-treats-javascript-as-parseable-datasource-assets","data-node-index":20}},"id":"skypager-treats-javascript-as-parseable-datasource-assets","value":"Skypager treats Javascript as parseable DataSource assets","parentId":"specifications"},{"type":"code","lang":"javascript","value":"project.content.data_sources.at('community-plugins').should.have.property('assetType', 'DataSource')\nproject.content.data_sources.at('community-plugins').should.have.property('parser')","position":{"start":{"line":64,"column":1},"end":{"line":67,"column":4},"indent":[1,1,1]},"index":21,"depth":3,"parentId":"skypager-treats-javascript-as-parseable-datasource-assets","childIndex":0,"childId":"code-3-1","id":"skypager-treats-javascript-as-parseable-datasource-assets-code-3-1","data":{"htmlAttributes":{"data-node-index":21}}}],"position":{"start":{"line":1,"column":1},"end":{"line":68,"column":1}}},"indexes":{"ids":{"assets":0,"assets-p-1-1":1,"assets-p-1-2":2,"assets-p-1-3":3,"specifications":4,"skypager-makes-assets-available-through-different-collections":5,"skypager-makes-assets-available-through-different-collections-code-3-1":6,"skypager-treats-svg-assets-as-normal-assets":7,"skypager-treats-svg-assets-as-normal-assets-p-3-1":8,"skypager-treats-svg-assets-as-normal-assets-code-3-2":9,"skypager-assets-have-a-dedicated-parser":10,"skypager-assets-have-a-dedicated-parser-code-3-1":11,"skypager-treats-markdown-as-document-assets":12,"skypager-treats-markdown-as-document-assets-code-3-1":13,"skypager-treats-json-as-parseable-datasource-assets":14,"skypager-treats-json-as-parseable-datasource-assets-code-3-1":15,"skypager-treats-yaml-as-parseable-datasource-assets":16,"skypager-treats-yaml-as-parseable-datasource-assets-code-3-1":17,"skypager-treats-csv-as-parseable-datasource-assets":18,"skypager-treats-csv-as-parseable-datasource-assets-code-3-1":19,"skypager-treats-javascript-as-parseable-datasource-assets":20,"skypager-treats-javascript-as-parseable-datasource-assets-code-3-1":21},"depths":{"1":[0],"2":[4],"3":[5,7,10,12,14,16,18,20],"4":[],"5":[],"6":[]},"types":{"heading":[0,4,5,7,10,12,14,16,18,20],"paragraph":[1,2,3,8],"code":[6,9,11,13,15,17,19,21]},"childrenIndexes":{"assets-spec":[0],"assets":[1,2,3,4],"specifications":[5,7,10,12,14,16,18,20],"skypager-makes-assets-available-through-different-collections":[6],"skypager-treats-svg-assets-as-normal-assets":[8,9],"skypager-assets-have-a-dedicated-parser":[11],"skypager-treats-markdown-as-document-assets":[13],"skypager-treats-json-as-parseable-datasource-assets":[15],"skypager-treats-yaml-as-parseable-datasource-assets":[17],"skypager-treats-csv-as-parseable-datasource-assets":[19],"skypager-treats-javascript-as-parseable-datasource-assets":[21]}},"html":"<main id=\"assets-spec\" class=\"skypager-document \"><h1 id=\"assets\" data-node-index=\"\">Assets</h1><p data-node-index=\"1\">Skypager Projects consist of two types of files: <code>Assets</code> and <code>Helpers</code></p><p data-node-index=\"2\">Assets consist of content such as markdown writing, or files that contain data, code, or images.</p><p data-node-index=\"3\">Assets which can be parsed can be used to generate data for the Project&apos;s entities.</p><section class=\"depth-2 sections\" id=\"specifications\" data-node-index=\"4\"><h2 id=\"specifications\">Specifications</h2><article class=\"depth-3 articles\" id=\"skypager-makes-assets-available-through-different-collections\" data-node-index=\"5\"><h3 id=\"skypager-makes-assets-available-through-different-collections\">Skypager makes assets available through different collections</h3><pre><code data-node-index=\"6\">project.content.documents.assets.should.not.be.empty()\nproject.content.assets.assets.should.not.be.empty()\nproject.content.data_sources.assets.should.not.be.empty()\n</code></pre></article><article class=\"depth-3 articles\" id=\"skypager-treats-svg-assets-as-normal-assets\" data-node-index=\"7\"><h3 id=\"skypager-treats-svg-assets-as-normal-assets\">Skypager treats svg assets as normal Assets</h3><p data-node-index=\"8\">SVG Assets can be embedded in rendered markdown documents by using a special embed syntax.</p><pre><code data-node-index=\"9\">project.content.assets.at(&apos;example&apos;).uri.should.match(/example.svg/)\nproject.content.assets.at(&apos;example&apos;).should.have.property(&apos;assetType&apos;, &apos;asset&apos;)\n</code></pre></article><article class=\"depth-3 articles\" id=\"skypager-assets-have-a-dedicated-parser\" data-node-index=\"10\"><h3 id=\"skypager-assets-have-a-dedicated-parser\">Skypager assets have a dedicated parser</h3><pre><code data-node-index=\"11\">project.content.documents.at(&apos;index&apos;).parser.should.be.a.Function\n</code></pre></article><article class=\"depth-3 articles\" id=\"skypager-treats-markdown-as-document-assets\" data-node-index=\"12\"><h3 id=\"skypager-treats-markdown-as-document-assets\">Skypager treats markdown as Document assets</h3><pre><code data-node-index=\"13\">project.content.documents.at(&apos;index&apos;).should.have.property(&apos;assetType&apos;, &apos;document&apos;)\nproject.content.documents.at(&apos;index&apos;).should.have.property(&apos;parser&apos;)\n</code></pre></article><article class=\"depth-3 articles\" id=\"skypager-treats-json-as-parseable-datasource-assets\" data-node-index=\"14\"><h3 id=\"skypager-treats-json-as-parseable-datasource-assets\">Skypager treats JSON as parseable DataSource assets</h3><pre><code data-node-index=\"15\">project.content.data_sources.at(&apos;example&apos;).should.have.property(&apos;assetType&apos;, &apos;DataSource&apos;)\nproject.content.data_sources.at(&apos;example&apos;).should.have.property(&apos;parser&apos;)\n</code></pre></article><article class=\"depth-3 articles\" id=\"skypager-treats-yaml-as-parseable-datasource-assets\" data-node-index=\"16\"><h3 id=\"skypager-treats-yaml-as-parseable-datasource-assets\">Skypager treats YAML as parseable DataSource assets</h3><pre><code data-node-index=\"17\">project.content.data_sources.at(&apos;inspiration&apos;).should.have.property(&apos;assetType&apos;, &apos;DataSource&apos;)\nproject.content.data_sources.at(&apos;inspiration&apos;).should.have.property(&apos;parser&apos;)\n</code></pre></article><article class=\"depth-3 articles\" id=\"skypager-treats-csv-as-parseable-datasource-assets\" data-node-index=\"18\"><h3 id=\"skypager-treats-csv-as-parseable-datasource-assets\">Skypager treats CSV as parseable DataSource assets</h3><pre><code data-node-index=\"19\">project.content.data_sources.at(&apos;tabular&apos;).should.have.property(&apos;assetType&apos;, &apos;DataSource&apos;)\nproject.content.data_sources.at(&apos;tabular&apos;).should.have.property(&apos;parser&apos;)\n</code></pre></article><article class=\"depth-3 articles\" id=\"skypager-treats-javascript-as-parseable-datasource-assets\" data-node-index=\"20\"><h3 id=\"skypager-treats-javascript-as-parseable-datasource-assets\">Skypager treats Javascript as parseable DataSource assets</h3><pre><code data-node-index=\"21\">project.content.data_sources.at(&apos;community-plugins&apos;).should.have.property(&apos;assetType&apos;, &apos;DataSource&apos;)\nproject.content.data_sources.at(&apos;community-plugins&apos;).should.have.property(&apos;parser&apos;)\n</code></pre></article></section></main>\n"};