module.exports = {"id":"entity-models-spec","paths":{"relative":"entity-models-spec.md","project":"docs/entity-models-spec.md","projectRequire":"docs/entity-models-spec.md","absolute":"/Users/jonathan/Skypager/packages/skypager/test/fixture/docs/entity-models-spec.md"},"assetGroup":"documents","fingerprint":"cece7ccb4aef233027ba1487868701f1","markdown":"Skypager makes it easy to take the parsed data from the project, and bring them alive through the use of Models.  Models are templates which describe an interface for specific types of Entities that are referenced in the project.  \n\n## Specifications \n\n### Skypager ships with some entities\n\nSkypager ships with a couple of entities.\n\n```javascript\nproject.models.available.should.containEql('Outline','Page')\n```\n\n#### Outlines\n\nAn Outline can a simple Table of Contents.  \n\nOutlines once parsed, are a great way to start a project and then automatically generate the appropriate documents in the proper place based on the headings. \n\n```javascript\nvar outlineModel = project.models.lookup('Outline')\n\noutlineModel.attributeNames.should.containEql('title','sections','subsections')\n```\n\n#### Pages\n\nPages are just simple documents with titles.\n\n```javascript\nvar pageModel = project.models.lookup('Page')\n\npageModel.attributeNames.should.containEql('title')\n```\n\n### Entity types can be inferred from the folder they belong to\n\n### Entity types can be specified by the file metadata\n\n### Entity types can be forced at a project level\n\n### Entity types can be determined on an asset by asset basis as well\n","ast":{"type":"root","children":[{"type":"paragraph","children":[{"type":"text","value":"Skypager makes it easy to take the parsed data from the project, and bring them alive through the use of Models.  Models are templates which describe an interface for specific types of Entities that are referenced in the project.  ","position":{"start":{"line":1,"column":1},"end":{"line":1,"column":232},"indent":[]}}],"position":{"start":{"line":1,"column":1},"end":{"line":1,"column":232},"indent":[]},"index":0,"depth":1,"parentId":"entity-models-spec","childIndex":0,"childId":"p-1-1","id":"entity-models-spec-p-1-1","data":{"htmlAttributes":{"data-node-index":0}}},{"type":"section","depth":2,"children":[{"type":"heading","depth":2,"children":[{"type":"text","value":"Specifications","position":{"start":{"line":3,"column":4},"end":{"line":3,"column":18},"indent":[]}}],"position":{"start":{"line":3,"column":1},"end":{"line":3,"column":19},"indent":[]},"index":1,"data":{"htmlAttributes":{"id":"specifications"}},"id":"specifications","value":"Specifications","parentId":"entity-models-spec"},{"type":"article","depth":3,"children":[{"type":"heading","depth":3,"children":[{"type":"text","value":"Skypager ships with some entities","position":{"start":{"line":5,"column":5},"end":{"line":5,"column":38},"indent":[]}}],"position":{"start":{"line":5,"column":1},"end":{"line":5,"column":38},"indent":[]},"index":2,"data":{"htmlAttributes":{"id":"skypager-ships-with-some-entities"}},"id":"skypager-ships-with-some-entities","value":"Skypager ships with some entities","parentId":"specifications"},{"type":"paragraph","children":[{"type":"text","value":"Skypager ships with a couple of entities.","position":{"start":{"line":7,"column":1},"end":{"line":7,"column":42},"indent":[]}}],"position":{"start":{"line":7,"column":1},"end":{"line":7,"column":42},"indent":[]},"index":3,"depth":3,"parentId":"skypager-ships-with-some-entities","childIndex":0,"childId":"p-3-1","id":"skypager-ships-with-some-entities-p-3-1","data":{"htmlAttributes":{"data-node-index":3}}},{"type":"code","lang":"javascript","value":"project.models.available.should.containEql('Outline','Page')","position":{"start":{"line":9,"column":1},"end":{"line":11,"column":4},"indent":[1,1]},"index":4,"depth":3,"parentId":"skypager-ships-with-some-entities","childIndex":1,"childId":"code-3-2","id":"skypager-ships-with-some-entities-code-3-2","data":{"htmlAttributes":{"data-node-index":4}}},{"type":"div","depth":4,"children":[{"type":"heading","depth":4,"children":[{"type":"text","value":"Outlines","position":{"start":{"line":13,"column":6},"end":{"line":13,"column":14},"indent":[]}}],"position":{"start":{"line":13,"column":1},"end":{"line":13,"column":14},"indent":[]},"index":5,"data":{"htmlAttributes":{"id":"outlines"}},"id":"outlines","value":"Outlines","parentId":"skypager-ships-with-some-entities"},{"type":"paragraph","children":[{"type":"text","value":"An Outline can a simple Table of Contents.  ","position":{"start":{"line":15,"column":1},"end":{"line":15,"column":45},"indent":[]}}],"position":{"start":{"line":15,"column":1},"end":{"line":15,"column":45},"indent":[]},"index":6,"depth":4,"parentId":"outlines","childIndex":0,"childId":"p-4-1","id":"outlines-p-4-1","data":{"htmlAttributes":{"data-node-index":6}}},{"type":"paragraph","children":[{"type":"text","value":"Outlines once parsed, are a great way to start a project and then automatically generate the appropriate documents in the proper place based on the headings. ","position":{"start":{"line":17,"column":1},"end":{"line":17,"column":159},"indent":[]}}],"position":{"start":{"line":17,"column":1},"end":{"line":17,"column":159},"indent":[]},"index":7,"depth":4,"parentId":"outlines","childIndex":1,"childId":"p-4-2","id":"outlines-p-4-2","data":{"htmlAttributes":{"data-node-index":7}}},{"type":"code","lang":"javascript","value":"var outlineModel = project.models.lookup('Outline')\n\noutlineModel.attributeNames.should.containEql('title','sections','subsections')","position":{"start":{"line":19,"column":1},"end":{"line":23,"column":4},"indent":[1,1,1,1]},"index":8,"depth":4,"parentId":"outlines","childIndex":2,"childId":"code-4-3","id":"outlines-code-4-3","data":{"htmlAttributes":{"data-node-index":8}}}],"position":{"start":{"line":13,"column":1},"end":{"line":13,"column":14},"indent":[]},"index":5,"data":{"htmlName":"div","htmlAttributes":{"class":"depth-4","id":"outlines","data-node-index":5}},"id":"outlines","value":"Outlines","parentId":"skypager-ships-with-some-entities"},{"type":"div","depth":4,"children":[{"type":"heading","depth":4,"children":[{"type":"text","value":"Pages","position":{"start":{"line":25,"column":6},"end":{"line":25,"column":11},"indent":[]}}],"position":{"start":{"line":25,"column":1},"end":{"line":25,"column":11},"indent":[]},"index":9,"data":{"htmlAttributes":{"id":"pages"}},"id":"pages","value":"Pages","parentId":"skypager-ships-with-some-entities"},{"type":"paragraph","children":[{"type":"text","value":"Pages are just simple documents with titles.","position":{"start":{"line":27,"column":1},"end":{"line":27,"column":45},"indent":[]}}],"position":{"start":{"line":27,"column":1},"end":{"line":27,"column":45},"indent":[]},"index":10,"depth":4,"parentId":"pages","childIndex":0,"childId":"p-4-1","id":"pages-p-4-1","data":{"htmlAttributes":{"data-node-index":10}}},{"type":"code","lang":"javascript","value":"var pageModel = project.models.lookup('Page')\n\npageModel.attributeNames.should.containEql('title')","position":{"start":{"line":29,"column":1},"end":{"line":33,"column":4},"indent":[1,1,1,1]},"index":11,"depth":4,"parentId":"pages","childIndex":1,"childId":"code-4-2","id":"pages-code-4-2","data":{"htmlAttributes":{"data-node-index":11}}}],"position":{"start":{"line":25,"column":1},"end":{"line":25,"column":11},"indent":[]},"index":9,"data":{"htmlName":"div","htmlAttributes":{"class":"depth-4","id":"pages","data-node-index":9}},"id":"pages","value":"Pages","parentId":"skypager-ships-with-some-entities"}],"position":{"start":{"line":5,"column":1},"end":{"line":5,"column":38},"indent":[]},"index":2,"data":{"htmlName":"article","htmlAttributes":{"class":"depth-3 articles","id":"skypager-ships-with-some-entities","data-node-index":2}},"id":"skypager-ships-with-some-entities","value":"Skypager ships with some entities","parentId":"specifications"},{"type":"article","depth":3,"children":[{"type":"heading","depth":3,"children":[{"type":"text","value":"Entity types can be inferred from the folder they belong to","position":{"start":{"line":35,"column":5},"end":{"line":35,"column":64},"indent":[]}}],"position":{"start":{"line":35,"column":1},"end":{"line":35,"column":64},"indent":[]},"index":12,"data":{"htmlAttributes":{"id":"entity-types-can-be-inferred-from-the-folder-they-belong-to"}},"id":"entity-types-can-be-inferred-from-the-folder-they-belong-to","value":"Entity types can be inferred from the folder they belong to","parentId":"specifications"}],"position":{"start":{"line":35,"column":1},"end":{"line":35,"column":64},"indent":[]},"index":12,"data":{"htmlName":"article","htmlAttributes":{"class":"depth-3 articles","id":"entity-types-can-be-inferred-from-the-folder-they-belong-to","data-node-index":12}},"id":"entity-types-can-be-inferred-from-the-folder-they-belong-to","value":"Entity types can be inferred from the folder they belong to","parentId":"specifications"},{"type":"article","depth":3,"children":[{"type":"heading","depth":3,"children":[{"type":"text","value":"Entity types can be specified by the file metadata","position":{"start":{"line":37,"column":5},"end":{"line":37,"column":55},"indent":[]}}],"position":{"start":{"line":37,"column":1},"end":{"line":37,"column":55},"indent":[]},"index":13,"data":{"htmlAttributes":{"id":"entity-types-can-be-specified-by-the-file-metadata"}},"id":"entity-types-can-be-specified-by-the-file-metadata","value":"Entity types can be specified by the file metadata","parentId":"specifications"}],"position":{"start":{"line":37,"column":1},"end":{"line":37,"column":55},"indent":[]},"index":13,"data":{"htmlName":"article","htmlAttributes":{"class":"depth-3 articles","id":"entity-types-can-be-specified-by-the-file-metadata","data-node-index":13}},"id":"entity-types-can-be-specified-by-the-file-metadata","value":"Entity types can be specified by the file metadata","parentId":"specifications"},{"type":"article","depth":3,"children":[{"type":"heading","depth":3,"children":[{"type":"text","value":"Entity types can be forced at a project level","position":{"start":{"line":39,"column":5},"end":{"line":39,"column":50},"indent":[]}}],"position":{"start":{"line":39,"column":1},"end":{"line":39,"column":50},"indent":[]},"index":14,"data":{"htmlAttributes":{"id":"entity-types-can-be-forced-at-a-project-level"}},"id":"entity-types-can-be-forced-at-a-project-level","value":"Entity types can be forced at a project level","parentId":"specifications"}],"position":{"start":{"line":39,"column":1},"end":{"line":39,"column":50},"indent":[]},"index":14,"data":{"htmlName":"article","htmlAttributes":{"class":"depth-3 articles","id":"entity-types-can-be-forced-at-a-project-level","data-node-index":14}},"id":"entity-types-can-be-forced-at-a-project-level","value":"Entity types can be forced at a project level","parentId":"specifications"},{"type":"article","depth":3,"children":[{"type":"heading","depth":3,"children":[{"type":"text","value":"Entity types can be determined on an asset by asset basis as well","position":{"start":{"line":41,"column":5},"end":{"line":41,"column":70},"indent":[]}}],"position":{"start":{"line":41,"column":1},"end":{"line":41,"column":70},"indent":[]},"index":15,"data":{"htmlAttributes":{"id":"entity-types-can-be-determined-on-an-asset-by-asset-basis-as-well"}},"id":"entity-types-can-be-determined-on-an-asset-by-asset-basis-as-well","value":"Entity types can be determined on an asset by asset basis as well","parentId":"specifications"}],"position":{"start":{"line":41,"column":1},"end":{"line":41,"column":70},"indent":[]},"index":15,"data":{"htmlName":"article","htmlAttributes":{"class":"depth-3 articles","id":"entity-types-can-be-determined-on-an-asset-by-asset-basis-as-well","data-node-index":15}},"id":"entity-types-can-be-determined-on-an-asset-by-asset-basis-as-well","value":"Entity types can be determined on an asset by asset basis as well","parentId":"specifications"}],"position":{"start":{"line":3,"column":1},"end":{"line":3,"column":19},"indent":[]},"index":1,"data":{"htmlName":"section","htmlAttributes":{"class":"depth-2 sections","id":"specifications","data-node-index":1}},"id":"specifications","value":"Specifications","parentId":"entity-models-spec"},{"type":"article","depth":3,"children":[{"type":"heading","depth":3,"children":[{"type":"text","value":"Skypager ships with some entities","position":{"start":{"line":5,"column":5},"end":{"line":5,"column":38},"indent":[]}}],"position":{"start":{"line":5,"column":1},"end":{"line":5,"column":38},"indent":[]},"index":2,"data":{"htmlAttributes":{"id":"skypager-ships-with-some-entities"}},"id":"skypager-ships-with-some-entities","value":"Skypager ships with some entities","parentId":"specifications"},{"type":"paragraph","children":[{"type":"text","value":"Skypager ships with a couple of entities.","position":{"start":{"line":7,"column":1},"end":{"line":7,"column":42},"indent":[]}}],"position":{"start":{"line":7,"column":1},"end":{"line":7,"column":42},"indent":[]},"index":3,"depth":3,"parentId":"skypager-ships-with-some-entities","childIndex":0,"childId":"p-3-1","id":"skypager-ships-with-some-entities-p-3-1","data":{"htmlAttributes":{"data-node-index":3}}},{"type":"code","lang":"javascript","value":"project.models.available.should.containEql('Outline','Page')","position":{"start":{"line":9,"column":1},"end":{"line":11,"column":4},"indent":[1,1]},"index":4,"depth":3,"parentId":"skypager-ships-with-some-entities","childIndex":1,"childId":"code-3-2","id":"skypager-ships-with-some-entities-code-3-2","data":{"htmlAttributes":{"data-node-index":4}}},{"type":"div","depth":4,"children":[{"type":"heading","depth":4,"children":[{"type":"text","value":"Outlines","position":{"start":{"line":13,"column":6},"end":{"line":13,"column":14},"indent":[]}}],"position":{"start":{"line":13,"column":1},"end":{"line":13,"column":14},"indent":[]},"index":5,"data":{"htmlAttributes":{"id":"outlines"}},"id":"outlines","value":"Outlines","parentId":"skypager-ships-with-some-entities"},{"type":"paragraph","children":[{"type":"text","value":"An Outline can a simple Table of Contents.  ","position":{"start":{"line":15,"column":1},"end":{"line":15,"column":45},"indent":[]}}],"position":{"start":{"line":15,"column":1},"end":{"line":15,"column":45},"indent":[]},"index":6,"depth":4,"parentId":"outlines","childIndex":0,"childId":"p-4-1","id":"outlines-p-4-1","data":{"htmlAttributes":{"data-node-index":6}}},{"type":"paragraph","children":[{"type":"text","value":"Outlines once parsed, are a great way to start a project and then automatically generate the appropriate documents in the proper place based on the headings. ","position":{"start":{"line":17,"column":1},"end":{"line":17,"column":159},"indent":[]}}],"position":{"start":{"line":17,"column":1},"end":{"line":17,"column":159},"indent":[]},"index":7,"depth":4,"parentId":"outlines","childIndex":1,"childId":"p-4-2","id":"outlines-p-4-2","data":{"htmlAttributes":{"data-node-index":7}}},{"type":"code","lang":"javascript","value":"var outlineModel = project.models.lookup('Outline')\n\noutlineModel.attributeNames.should.containEql('title','sections','subsections')","position":{"start":{"line":19,"column":1},"end":{"line":23,"column":4},"indent":[1,1,1,1]},"index":8,"depth":4,"parentId":"outlines","childIndex":2,"childId":"code-4-3","id":"outlines-code-4-3","data":{"htmlAttributes":{"data-node-index":8}}}],"position":{"start":{"line":13,"column":1},"end":{"line":13,"column":14},"indent":[]},"index":5,"data":{"htmlName":"div","htmlAttributes":{"class":"depth-4","id":"outlines","data-node-index":5}},"id":"outlines","value":"Outlines","parentId":"skypager-ships-with-some-entities"},{"type":"div","depth":4,"children":[{"type":"heading","depth":4,"children":[{"type":"text","value":"Pages","position":{"start":{"line":25,"column":6},"end":{"line":25,"column":11},"indent":[]}}],"position":{"start":{"line":25,"column":1},"end":{"line":25,"column":11},"indent":[]},"index":9,"data":{"htmlAttributes":{"id":"pages"}},"id":"pages","value":"Pages","parentId":"skypager-ships-with-some-entities"},{"type":"paragraph","children":[{"type":"text","value":"Pages are just simple documents with titles.","position":{"start":{"line":27,"column":1},"end":{"line":27,"column":45},"indent":[]}}],"position":{"start":{"line":27,"column":1},"end":{"line":27,"column":45},"indent":[]},"index":10,"depth":4,"parentId":"pages","childIndex":0,"childId":"p-4-1","id":"pages-p-4-1","data":{"htmlAttributes":{"data-node-index":10}}},{"type":"code","lang":"javascript","value":"var pageModel = project.models.lookup('Page')\n\npageModel.attributeNames.should.containEql('title')","position":{"start":{"line":29,"column":1},"end":{"line":33,"column":4},"indent":[1,1,1,1]},"index":11,"depth":4,"parentId":"pages","childIndex":1,"childId":"code-4-2","id":"pages-code-4-2","data":{"htmlAttributes":{"data-node-index":11}}}],"position":{"start":{"line":25,"column":1},"end":{"line":25,"column":11},"indent":[]},"index":9,"data":{"htmlName":"div","htmlAttributes":{"class":"depth-4","id":"pages","data-node-index":9}},"id":"pages","value":"Pages","parentId":"skypager-ships-with-some-entities"}],"position":{"start":{"line":5,"column":1},"end":{"line":5,"column":38},"indent":[]},"index":2,"data":{"htmlName":"article","htmlAttributes":{"class":"depth-3 articles","id":"skypager-ships-with-some-entities","data-node-index":2}},"id":"skypager-ships-with-some-entities","value":"Skypager ships with some entities","parentId":"specifications"},{"type":"paragraph","children":[{"type":"text","value":"Skypager ships with a couple of entities.","position":{"start":{"line":7,"column":1},"end":{"line":7,"column":42},"indent":[]}}],"position":{"start":{"line":7,"column":1},"end":{"line":7,"column":42},"indent":[]},"index":3,"depth":3,"parentId":"skypager-ships-with-some-entities","childIndex":0,"childId":"p-3-1","id":"skypager-ships-with-some-entities-p-3-1","data":{"htmlAttributes":{"data-node-index":3}}},{"type":"code","lang":"javascript","value":"project.models.available.should.containEql('Outline','Page')","position":{"start":{"line":9,"column":1},"end":{"line":11,"column":4},"indent":[1,1]},"index":4,"depth":3,"parentId":"skypager-ships-with-some-entities","childIndex":1,"childId":"code-3-2","id":"skypager-ships-with-some-entities-code-3-2","data":{"htmlAttributes":{"data-node-index":4}}},{"type":"div","depth":4,"children":[{"type":"heading","depth":4,"children":[{"type":"text","value":"Outlines","position":{"start":{"line":13,"column":6},"end":{"line":13,"column":14},"indent":[]}}],"position":{"start":{"line":13,"column":1},"end":{"line":13,"column":14},"indent":[]},"index":5,"data":{"htmlAttributes":{"id":"outlines"}},"id":"outlines","value":"Outlines","parentId":"skypager-ships-with-some-entities"},{"type":"paragraph","children":[{"type":"text","value":"An Outline can a simple Table of Contents.  ","position":{"start":{"line":15,"column":1},"end":{"line":15,"column":45},"indent":[]}}],"position":{"start":{"line":15,"column":1},"end":{"line":15,"column":45},"indent":[]},"index":6,"depth":4,"parentId":"outlines","childIndex":0,"childId":"p-4-1","id":"outlines-p-4-1","data":{"htmlAttributes":{"data-node-index":6}}},{"type":"paragraph","children":[{"type":"text","value":"Outlines once parsed, are a great way to start a project and then automatically generate the appropriate documents in the proper place based on the headings. ","position":{"start":{"line":17,"column":1},"end":{"line":17,"column":159},"indent":[]}}],"position":{"start":{"line":17,"column":1},"end":{"line":17,"column":159},"indent":[]},"index":7,"depth":4,"parentId":"outlines","childIndex":1,"childId":"p-4-2","id":"outlines-p-4-2","data":{"htmlAttributes":{"data-node-index":7}}},{"type":"code","lang":"javascript","value":"var outlineModel = project.models.lookup('Outline')\n\noutlineModel.attributeNames.should.containEql('title','sections','subsections')","position":{"start":{"line":19,"column":1},"end":{"line":23,"column":4},"indent":[1,1,1,1]},"index":8,"depth":4,"parentId":"outlines","childIndex":2,"childId":"code-4-3","id":"outlines-code-4-3","data":{"htmlAttributes":{"data-node-index":8}}}],"position":{"start":{"line":13,"column":1},"end":{"line":13,"column":14},"indent":[]},"index":5,"data":{"htmlName":"div","htmlAttributes":{"class":"depth-4","id":"outlines","data-node-index":5}},"id":"outlines","value":"Outlines","parentId":"skypager-ships-with-some-entities"},{"type":"paragraph","children":[{"type":"text","value":"An Outline can a simple Table of Contents.  ","position":{"start":{"line":15,"column":1},"end":{"line":15,"column":45},"indent":[]}}],"position":{"start":{"line":15,"column":1},"end":{"line":15,"column":45},"indent":[]},"index":6,"depth":4,"parentId":"outlines","childIndex":0,"childId":"p-4-1","id":"outlines-p-4-1","data":{"htmlAttributes":{"data-node-index":6}}},{"type":"paragraph","children":[{"type":"text","value":"Outlines once parsed, are a great way to start a project and then automatically generate the appropriate documents in the proper place based on the headings. ","position":{"start":{"line":17,"column":1},"end":{"line":17,"column":159},"indent":[]}}],"position":{"start":{"line":17,"column":1},"end":{"line":17,"column":159},"indent":[]},"index":7,"depth":4,"parentId":"outlines","childIndex":1,"childId":"p-4-2","id":"outlines-p-4-2","data":{"htmlAttributes":{"data-node-index":7}}},{"type":"code","lang":"javascript","value":"var outlineModel = project.models.lookup('Outline')\n\noutlineModel.attributeNames.should.containEql('title','sections','subsections')","position":{"start":{"line":19,"column":1},"end":{"line":23,"column":4},"indent":[1,1,1,1]},"index":8,"depth":4,"parentId":"outlines","childIndex":2,"childId":"code-4-3","id":"outlines-code-4-3","data":{"htmlAttributes":{"data-node-index":8}}},{"type":"div","depth":4,"children":[{"type":"heading","depth":4,"children":[{"type":"text","value":"Pages","position":{"start":{"line":25,"column":6},"end":{"line":25,"column":11},"indent":[]}}],"position":{"start":{"line":25,"column":1},"end":{"line":25,"column":11},"indent":[]},"index":9,"data":{"htmlAttributes":{"id":"pages"}},"id":"pages","value":"Pages","parentId":"skypager-ships-with-some-entities"},{"type":"paragraph","children":[{"type":"text","value":"Pages are just simple documents with titles.","position":{"start":{"line":27,"column":1},"end":{"line":27,"column":45},"indent":[]}}],"position":{"start":{"line":27,"column":1},"end":{"line":27,"column":45},"indent":[]},"index":10,"depth":4,"parentId":"pages","childIndex":0,"childId":"p-4-1","id":"pages-p-4-1","data":{"htmlAttributes":{"data-node-index":10}}},{"type":"code","lang":"javascript","value":"var pageModel = project.models.lookup('Page')\n\npageModel.attributeNames.should.containEql('title')","position":{"start":{"line":29,"column":1},"end":{"line":33,"column":4},"indent":[1,1,1,1]},"index":11,"depth":4,"parentId":"pages","childIndex":1,"childId":"code-4-2","id":"pages-code-4-2","data":{"htmlAttributes":{"data-node-index":11}}}],"position":{"start":{"line":25,"column":1},"end":{"line":25,"column":11},"indent":[]},"index":9,"data":{"htmlName":"div","htmlAttributes":{"class":"depth-4","id":"pages","data-node-index":9}},"id":"pages","value":"Pages","parentId":"skypager-ships-with-some-entities"},{"type":"paragraph","children":[{"type":"text","value":"Pages are just simple documents with titles.","position":{"start":{"line":27,"column":1},"end":{"line":27,"column":45},"indent":[]}}],"position":{"start":{"line":27,"column":1},"end":{"line":27,"column":45},"indent":[]},"index":10,"depth":4,"parentId":"pages","childIndex":0,"childId":"p-4-1","id":"pages-p-4-1","data":{"htmlAttributes":{"data-node-index":10}}},{"type":"code","lang":"javascript","value":"var pageModel = project.models.lookup('Page')\n\npageModel.attributeNames.should.containEql('title')","position":{"start":{"line":29,"column":1},"end":{"line":33,"column":4},"indent":[1,1,1,1]},"index":11,"depth":4,"parentId":"pages","childIndex":1,"childId":"code-4-2","id":"pages-code-4-2","data":{"htmlAttributes":{"data-node-index":11}}},{"type":"article","depth":3,"children":[{"type":"heading","depth":3,"children":[{"type":"text","value":"Entity types can be inferred from the folder they belong to","position":{"start":{"line":35,"column":5},"end":{"line":35,"column":64},"indent":[]}}],"position":{"start":{"line":35,"column":1},"end":{"line":35,"column":64},"indent":[]},"index":12,"data":{"htmlAttributes":{"id":"entity-types-can-be-inferred-from-the-folder-they-belong-to"}},"id":"entity-types-can-be-inferred-from-the-folder-they-belong-to","value":"Entity types can be inferred from the folder they belong to","parentId":"specifications"}],"position":{"start":{"line":35,"column":1},"end":{"line":35,"column":64},"indent":[]},"index":12,"data":{"htmlName":"article","htmlAttributes":{"class":"depth-3 articles","id":"entity-types-can-be-inferred-from-the-folder-they-belong-to","data-node-index":12}},"id":"entity-types-can-be-inferred-from-the-folder-they-belong-to","value":"Entity types can be inferred from the folder they belong to","parentId":"specifications"},{"type":"article","depth":3,"children":[{"type":"heading","depth":3,"children":[{"type":"text","value":"Entity types can be specified by the file metadata","position":{"start":{"line":37,"column":5},"end":{"line":37,"column":55},"indent":[]}}],"position":{"start":{"line":37,"column":1},"end":{"line":37,"column":55},"indent":[]},"index":13,"data":{"htmlAttributes":{"id":"entity-types-can-be-specified-by-the-file-metadata"}},"id":"entity-types-can-be-specified-by-the-file-metadata","value":"Entity types can be specified by the file metadata","parentId":"specifications"}],"position":{"start":{"line":37,"column":1},"end":{"line":37,"column":55},"indent":[]},"index":13,"data":{"htmlName":"article","htmlAttributes":{"class":"depth-3 articles","id":"entity-types-can-be-specified-by-the-file-metadata","data-node-index":13}},"id":"entity-types-can-be-specified-by-the-file-metadata","value":"Entity types can be specified by the file metadata","parentId":"specifications"},{"type":"article","depth":3,"children":[{"type":"heading","depth":3,"children":[{"type":"text","value":"Entity types can be forced at a project level","position":{"start":{"line":39,"column":5},"end":{"line":39,"column":50},"indent":[]}}],"position":{"start":{"line":39,"column":1},"end":{"line":39,"column":50},"indent":[]},"index":14,"data":{"htmlAttributes":{"id":"entity-types-can-be-forced-at-a-project-level"}},"id":"entity-types-can-be-forced-at-a-project-level","value":"Entity types can be forced at a project level","parentId":"specifications"}],"position":{"start":{"line":39,"column":1},"end":{"line":39,"column":50},"indent":[]},"index":14,"data":{"htmlName":"article","htmlAttributes":{"class":"depth-3 articles","id":"entity-types-can-be-forced-at-a-project-level","data-node-index":14}},"id":"entity-types-can-be-forced-at-a-project-level","value":"Entity types can be forced at a project level","parentId":"specifications"},{"type":"article","depth":3,"children":[{"type":"heading","depth":3,"children":[{"type":"text","value":"Entity types can be determined on an asset by asset basis as well","position":{"start":{"line":41,"column":5},"end":{"line":41,"column":70},"indent":[]}}],"position":{"start":{"line":41,"column":1},"end":{"line":41,"column":70},"indent":[]},"index":15,"data":{"htmlAttributes":{"id":"entity-types-can-be-determined-on-an-asset-by-asset-basis-as-well"}},"id":"entity-types-can-be-determined-on-an-asset-by-asset-basis-as-well","value":"Entity types can be determined on an asset by asset basis as well","parentId":"specifications"}],"position":{"start":{"line":41,"column":1},"end":{"line":41,"column":70},"indent":[]},"index":15,"data":{"htmlName":"article","htmlAttributes":{"class":"depth-3 articles","id":"entity-types-can-be-determined-on-an-asset-by-asset-basis-as-well","data-node-index":15}},"id":"entity-types-can-be-determined-on-an-asset-by-asset-basis-as-well","value":"Entity types can be determined on an asset by asset basis as well","parentId":"specifications"}],"position":{"start":{"line":1,"column":1},"end":{"line":42,"column":1}}},"indexes":{"ids":{"entity-models-spec-p-1-1":0,"specifications":1,"skypager-ships-with-some-entities":2,"skypager-ships-with-some-entities-p-3-1":3,"skypager-ships-with-some-entities-code-3-2":4,"outlines":5,"outlines-p-4-1":6,"outlines-p-4-2":7,"outlines-code-4-3":8,"pages":9,"pages-p-4-1":10,"pages-code-4-2":11,"entity-types-can-be-inferred-from-the-folder-they-belong-to":12,"entity-types-can-be-specified-by-the-file-metadata":13,"entity-types-can-be-forced-at-a-project-level":14,"entity-types-can-be-determined-on-an-asset-by-asset-basis-as-well":15},"depths":{"1":[],"2":[1],"3":[2,12,13,14,15],"4":[5,9],"5":[],"6":[]},"types":{"paragraph":[0,3,6,7,10],"heading":[1,2,5,9,12,13,14,15],"code":[4,8,11]},"childrenIndexes":{"entity-models-spec":[0,1],"specifications":[2,12,13,14,15],"skypager-ships-with-some-entities":[3,4,5,9],"outlines":[6,7,8],"pages":[10,11]}},"html":"<main id=\"entity-models-spec\" class=\"skypager-document \"><p data-node-index=\"\">Skypager makes it easy to take the parsed data from the project, and bring them alive through the use of Models.  Models are templates which describe an interface for specific types of Entities that are referenced in the project.</p><section class=\"depth-2 sections\" id=\"specifications\" data-node-index=\"1\"><h2 id=\"specifications\">Specifications</h2><article class=\"depth-3 articles\" id=\"skypager-ships-with-some-entities\" data-node-index=\"2\"><h3 id=\"skypager-ships-with-some-entities\">Skypager ships with some entities</h3><p data-node-index=\"3\">Skypager ships with a couple of entities.</p><pre><code data-node-index=\"4\">project.models.available.should.containEql(&apos;Outline&apos;,&apos;Page&apos;)\n</code></pre><div class=\"depth-4\" id=\"outlines\" data-node-index=\"5\"><h4 id=\"outlines\">Outlines</h4><p data-node-index=\"6\">An Outline can a simple Table of Contents.</p><p data-node-index=\"7\">Outlines once parsed, are a great way to start a project and then automatically generate the appropriate documents in the proper place based on the headings.</p><pre><code data-node-index=\"8\">var outlineModel = project.models.lookup(&apos;Outline&apos;)\n\noutlineModel.attributeNames.should.containEql(&apos;title&apos;,&apos;sections&apos;,&apos;subsections&apos;)\n</code></pre></div><div class=\"depth-4\" id=\"pages\" data-node-index=\"9\"><h4 id=\"pages\">Pages</h4><p data-node-index=\"10\">Pages are just simple documents with titles.</p><pre><code data-node-index=\"11\">var pageModel = project.models.lookup(&apos;Page&apos;)\n\npageModel.attributeNames.should.containEql(&apos;title&apos;)\n</code></pre></div></article><article class=\"depth-3 articles\" id=\"entity-types-can-be-inferred-from-the-folder-they-belong-to\" data-node-index=\"12\"><h3 id=\"entity-types-can-be-inferred-from-the-folder-they-belong-to\">Entity types can be inferred from the folder they belong to</h3></article><article class=\"depth-3 articles\" id=\"entity-types-can-be-specified-by-the-file-metadata\" data-node-index=\"13\"><h3 id=\"entity-types-can-be-specified-by-the-file-metadata\">Entity types can be specified by the file metadata</h3></article><article class=\"depth-3 articles\" id=\"entity-types-can-be-forced-at-a-project-level\" data-node-index=\"14\"><h3 id=\"entity-types-can-be-forced-at-a-project-level\">Entity types can be forced at a project level</h3></article><article class=\"depth-3 articles\" id=\"entity-types-can-be-determined-on-an-asset-by-asset-basis-as-well\" data-node-index=\"15\"><h3 id=\"entity-types-can-be-determined-on-an-asset-by-asset-basis-as-well\">Entity types can be determined on an asset by asset basis as well</h3></article></section></main>\n"};