module.exports = {"id":"examples/css-styleguide","paths":{"relative":"examples/css-styleguide.md","project":"docs/examples/css-styleguide.md","projectRequire":"docs/examples/css-styleguide.md","absolute":"/Users/jonathan/Skypager/packages/skypager/test/fixture/docs/examples/css-styleguide.md"},"assetGroup":"documents","fingerprint":"c518c7cd046b89943c637780e1d4b55d","markdown":"---\nscripts:\n  - examples/css-styleguide.js\nstylesheets:\n  - examples/css-styleguide.scss\n---\n\n# CSS Styleguide\n\nStyled tables can be created by adding the `table` and `styled` classes\ntogether like such:\n\n```html\n<table id=\"example-styled-table\" class='table styled'>\n  <tbody>\n    <tr>\n      <td>Row One Cell One</td>\n      <td>Row One Cell Two</td>\n    </tr>\n  </tbody>\n</table>\n```\n\nHere is the SCSS style code which implements this.\n\n```scss\n.table.styled {\n  color: pink;\n}\n```\n\nHere is some functionality\n\n```javascript\nvar table = document.getElementById('example-styled-table')\n\ntable.addEventListener('click', function(){ \n  alert('table clicked')\n})\n```\n\nThese things can be rendered on the page in such a way that you could do\ninteresting things, such as recreate js fiddle or codepen style tools\n","ast":{"type":"root","children":[{"type":"yaml","value":"scripts:\n  - examples/css-styleguide.js\nstylesheets:\n  - examples/css-styleguide.scss","position":{"start":{"line":1,"column":1},"end":{"line":6,"column":4},"indent":[1,1,1,1,1]},"index":0,"depth":1,"parentId":"examples__css-styleguide","childIndex":0,"childId":"yaml-1-1","id":"examples__css-styleguide-yaml-1-1","data":{"htmlAttributes":{"data-node-index":0}}},{"type":"heading","depth":1,"children":[{"type":"text","value":"CSS Styleguide","position":{"start":{"line":8,"column":3},"end":{"line":8,"column":17},"indent":[]}}],"position":{"start":{"line":8,"column":1},"end":{"line":8,"column":17},"indent":[]},"index":1,"data":{"htmlAttributes":{"id":"css-styleguide","data-node-index":1}},"id":"css-styleguide","value":"CSS Styleguide","parentId":"examples__css-styleguide"},{"type":"paragraph","children":[{"type":"text","value":"Styled tables can be created by adding the ","position":{"start":{"line":10,"column":1},"end":{"line":10,"column":44},"indent":[]}},{"type":"inlineCode","value":"table","position":{"start":{"line":10,"column":44},"end":{"line":10,"column":51},"indent":[]}},{"type":"text","value":" and ","position":{"start":{"line":10,"column":51},"end":{"line":10,"column":56},"indent":[]}},{"type":"inlineCode","value":"styled","position":{"start":{"line":10,"column":56},"end":{"line":10,"column":64},"indent":[]}},{"type":"text","value":" classes\ntogether like such:","position":{"start":{"line":10,"column":64},"end":{"line":11,"column":20},"indent":[1]}}],"position":{"start":{"line":10,"column":1},"end":{"line":11,"column":20},"indent":[1]},"index":2,"depth":1,"parentId":"css-styleguide","childIndex":0,"childId":"p-1-1","id":"css-styleguide-p-1-1","data":{"htmlAttributes":{"data-node-index":2}}},{"type":"code","lang":"html","value":"<table id=\"example-styled-table\" class='table styled'>\n  <tbody>\n    <tr>\n      <td>Row One Cell One</td>\n      <td>Row One Cell Two</td>\n    </tr>\n  </tbody>\n</table>","position":{"start":{"line":13,"column":1},"end":{"line":22,"column":4},"indent":[1,1,1,1,1,1,1,1,1]},"index":3,"depth":1,"parentId":"css-styleguide","childIndex":1,"childId":"code-1-2","id":"css-styleguide-code-1-2","data":{"htmlAttributes":{"data-node-index":3}}},{"type":"paragraph","children":[{"type":"text","value":"Here is the SCSS style code which implements this.","position":{"start":{"line":24,"column":1},"end":{"line":24,"column":51},"indent":[]}}],"position":{"start":{"line":24,"column":1},"end":{"line":24,"column":51},"indent":[]},"index":4,"depth":1,"parentId":"css-styleguide","childIndex":2,"childId":"p-1-3","id":"css-styleguide-p-1-3","data":{"htmlAttributes":{"data-node-index":4}}},{"type":"code","lang":"scss","value":".table.styled {\n  color: pink;\n}","position":{"start":{"line":26,"column":1},"end":{"line":30,"column":4},"indent":[1,1,1,1]},"index":5,"depth":1,"parentId":"css-styleguide","childIndex":3,"childId":"code-1-4","id":"css-styleguide-code-1-4","data":{"htmlAttributes":{"data-node-index":5}}},{"type":"paragraph","children":[{"type":"text","value":"Here is some functionality","position":{"start":{"line":32,"column":1},"end":{"line":32,"column":27},"indent":[]}}],"position":{"start":{"line":32,"column":1},"end":{"line":32,"column":27},"indent":[]},"index":6,"depth":1,"parentId":"css-styleguide","childIndex":4,"childId":"p-1-5","id":"css-styleguide-p-1-5","data":{"htmlAttributes":{"data-node-index":6}}},{"type":"code","lang":"javascript","value":"var table = document.getElementById('example-styled-table')\n\ntable.addEventListener('click', function(){ \n  alert('table clicked')\n})","position":{"start":{"line":34,"column":1},"end":{"line":40,"column":4},"indent":[1,1,1,1,1,1]},"index":7,"depth":1,"parentId":"css-styleguide","childIndex":5,"childId":"code-1-6","id":"css-styleguide-code-1-6","data":{"htmlAttributes":{"data-node-index":7}}},{"type":"paragraph","children":[{"type":"text","value":"These things can be rendered on the page in such a way that you could do\ninteresting things, such as recreate js fiddle or codepen style tools","position":{"start":{"line":42,"column":1},"end":{"line":43,"column":70},"indent":[1]}}],"position":{"start":{"line":42,"column":1},"end":{"line":43,"column":70},"indent":[1]},"index":8,"depth":1,"parentId":"css-styleguide","childIndex":6,"childId":"p-1-7","id":"css-styleguide-p-1-7","data":{"htmlAttributes":{"data-node-index":8}}}],"position":{"start":{"line":1,"column":1},"end":{"line":44,"column":1}}},"indexes":{"ids":{"examples__css-styleguide-yaml-1-1":0,"css-styleguide":1,"css-styleguide-p-1-1":2,"css-styleguide-code-1-2":3,"css-styleguide-p-1-3":4,"css-styleguide-code-1-4":5,"css-styleguide-p-1-5":6,"css-styleguide-code-1-6":7,"css-styleguide-p-1-7":8},"depths":{"1":[1],"2":[],"3":[],"4":[],"5":[],"6":[]},"types":{"yaml":[0],"heading":[1],"paragraph":[2,4,6,8],"code":[3,5,7]},"childrenIndexes":{"examples__css-styleguide":[0,1],"css-styleguide":[2,3,4,5,6,7,8]}},"html":"<main id=\"examples__css-styleguide\" class=\"skypager-document examples\"><h1 id=\"css-styleguide\" data-node-index=\"1\">CSS Styleguide</h1><p data-node-index=\"2\">Styled tables can be created by adding the <code>table</code> and <code>styled</code> classes\ntogether like such:</p><pre><code data-node-index=\"3\">&lt;table id=&quot;example-styled-table&quot; class=&apos;table styled&apos;&gt;\n  &lt;tbody&gt;\n    &lt;tr&gt;\n      &lt;td&gt;Row One Cell One&lt;/td&gt;\n      &lt;td&gt;Row One Cell Two&lt;/td&gt;\n    &lt;/tr&gt;\n  &lt;/tbody&gt;\n&lt;/table&gt;\n</code></pre><p data-node-index=\"4\">Here is the SCSS style code which implements this.</p><pre><code data-node-index=\"5\">.table.styled {\n  color: pink;\n}\n</code></pre><p data-node-index=\"6\">Here is some functionality</p><pre><code data-node-index=\"7\">var table = document.getElementById(&apos;example-styled-table&apos;)\n\ntable.addEventListener(&apos;click&apos;, function(){ \n  alert(&apos;table clicked&apos;)\n})\n</code></pre><p data-node-index=\"8\">These things can be rendered on the page in such a way that you could do\ninteresting things, such as recreate js fiddle or codepen style tools</p></main>\n"};