module.exports = {"id":"testcases/structure-spec","paths":{"relative":"testcases/structure-spec.md","project":"docs/testcases/structure-spec.md","projectRequire":"docs/testcases/structure-spec.md","absolute":"/Users/jonathan/Skypager/packages/skypager/test/fixture/docs/testcases/structure-spec.md"},"assetGroup":"documents","fingerprint":"899177675bf5f21470dc07b29cfe9399","markdown":"---\nexample: metadata\n---\n\nThis is a paragraph. I wanna see what happens when the first item isn't a title heading.\n\n- list item one\n- list item two\n\n# Document Structuring\n\nSkypager allows you to provide special meaning to the content of a\ndocument by including it under document headings.  Heading hierarchies\ncan be used by An Entity Model to build object trees, for example the\ndocument you are reading now has an `h2` specifications section that is\na required section for.\n\n[link:docs/assets/data-source-spec](Link Body Text)\n\n## Setup\n\nTo test the structuring of a document we will use this document as an example.\n\n```javascript\nvar document = project.documents.at('testcases/structure-spec')\n```\n\n## Specifications\n\n### Documents treat h2 as section headings \n\n```javascript\nvar sections = document.headings.sections\n\nsections.should.containEql('Setup','Specifications')\nsections.should.not.containEql('Article Heading B')\n```\n\n### Documents treat h3 as article headings \n\n```javascript\nvar articles = document.headings.articles\n\narticles.should.not.containEql('Setup','Specifications')\narticles.should.containEql('Article Heading B')\n```\n\n### Sections can be mapped back to their markdown line numbers\n\n```javascript\ndocument.sections.setup.beginsAt.should.have.property('line', 14)\ndocument.sections.setup.lines.should.have.property('length', 9)\n```\n\n### Sections reference their parent sections\n\n#### For Example\n\n```javascript\ndocument.nodes.at('for-example').parent.should.have.property('lineNumber', 44)\n```\n\n### Documents provide an easy way of accessing their sections\n\n## Usage \n\nHow you use this feature is up to you.\n","ast":{"type":"root","children":[{"type":"yaml","value":"example: metadata","position":{"start":{"line":1,"column":1},"end":{"line":3,"column":4},"indent":[1,1]},"index":0,"depth":1,"parentId":"testcases__structure-spec","childIndex":0,"childId":"yaml-1-1","id":"testcases__structure-spec-yaml-1-1","data":{"htmlAttributes":{"data-node-index":0}}},{"type":"paragraph","children":[{"type":"text","value":"This is a paragraph. I wanna see what happens when the first item isn't a title heading.","position":{"start":{"line":5,"column":1},"end":{"line":5,"column":89},"indent":[]}}],"position":{"start":{"line":5,"column":1},"end":{"line":5,"column":89},"indent":[]},"index":1,"depth":1,"parentId":"testcases__structure-spec","childIndex":1,"childId":"p-1-2","id":"testcases__structure-spec-p-1-2","data":{"htmlAttributes":{"data-node-index":1}}},{"type":"list","ordered":false,"start":null,"loose":false,"children":[{"type":"listItem","loose":false,"checked":null,"children":[{"type":"paragraph","children":[{"type":"text","value":"list item one","position":{"start":{"line":7,"column":3},"end":{"line":7,"column":16},"indent":[]}}],"position":{"start":{"line":7,"column":3},"end":{"line":7,"column":16},"indent":[]}}],"position":{"start":{"line":7,"column":1},"end":{"line":7,"column":16},"indent":[]}},{"type":"listItem","loose":false,"checked":null,"children":[{"type":"paragraph","children":[{"type":"text","value":"list item two","position":{"start":{"line":8,"column":3},"end":{"line":8,"column":16},"indent":[]}}],"position":{"start":{"line":8,"column":3},"end":{"line":8,"column":16},"indent":[]}}],"position":{"start":{"line":8,"column":1},"end":{"line":8,"column":16},"indent":[]}}],"position":{"start":{"line":7,"column":1},"end":{"line":8,"column":16},"indent":[1]},"index":2,"depth":1,"parentId":"testcases__structure-spec","childIndex":2,"childId":"list-1-3","id":"testcases__structure-spec-list-1-3","data":{"htmlAttributes":{"data-node-index":2}}},{"type":"heading","depth":1,"children":[{"type":"text","value":"Document Structuring","position":{"start":{"line":10,"column":3},"end":{"line":10,"column":23},"indent":[]}}],"position":{"start":{"line":10,"column":1},"end":{"line":10,"column":23},"indent":[]},"index":3,"data":{"htmlAttributes":{"id":"document-structuring","data-node-index":3}},"id":"document-structuring","value":"Document Structuring","parentId":"testcases__structure-spec"},{"type":"paragraph","children":[{"type":"text","value":"Skypager allows you to provide special meaning to the content of a\ndocument by including it under document headings.  Heading hierarchies\ncan be used by An Entity Model to build object trees, for example the\ndocument you are reading now has an ","position":{"start":{"line":12,"column":1},"end":{"line":15,"column":37},"indent":[1,1,1]}},{"type":"inlineCode","value":"h2","position":{"start":{"line":15,"column":37},"end":{"line":15,"column":41},"indent":[]}},{"type":"text","value":" specifications section that is\na required section for.","position":{"start":{"line":15,"column":41},"end":{"line":16,"column":24},"indent":[1]}}],"position":{"start":{"line":12,"column":1},"end":{"line":16,"column":24},"indent":[1,1,1,1]},"index":4,"depth":1,"parentId":"document-structuring","childIndex":0,"childId":"p-1-1","id":"document-structuring-p-1-1","data":{"htmlAttributes":{"data-node-index":4}}},{"type":"paragraph","children":[{"type":"link","title":null,"href":"Link Body Text","children":[{"type":"text","value":"link:docs/assets/data-source-spec","position":{"start":{"line":18,"column":2},"end":{"line":18,"column":35},"indent":[]}}],"position":{"start":{"line":18,"column":1},"end":{"line":18,"column":52},"indent":[]}}],"position":{"start":{"line":18,"column":1},"end":{"line":18,"column":52},"indent":[]},"index":5,"depth":1,"parentId":"document-structuring","childIndex":1,"childId":"p-1-2","id":"document-structuring-p-1-2","data":{"htmlAttributes":{"data-node-index":5}}},{"type":"section","depth":2,"children":[{"type":"heading","depth":2,"children":[{"type":"text","value":"Setup","position":{"start":{"line":20,"column":4},"end":{"line":20,"column":9},"indent":[]}}],"position":{"start":{"line":20,"column":1},"end":{"line":20,"column":9},"indent":[]},"index":6,"data":{"htmlAttributes":{"id":"setup"}},"id":"setup","value":"Setup","parentId":"document-structuring"},{"type":"paragraph","children":[{"type":"text","value":"To test the structuring of a document we will use this document as an example.","position":{"start":{"line":22,"column":1},"end":{"line":22,"column":79},"indent":[]}}],"position":{"start":{"line":22,"column":1},"end":{"line":22,"column":79},"indent":[]},"index":7,"depth":2,"parentId":"setup","childIndex":0,"childId":"p-2-1","id":"setup-p-2-1","data":{"htmlAttributes":{"data-node-index":7}}},{"type":"code","lang":"javascript","value":"var document = project.documents.at('testcases/structure-spec')","position":{"start":{"line":24,"column":1},"end":{"line":26,"column":4},"indent":[1,1]},"index":8,"depth":2,"parentId":"setup","childIndex":1,"childId":"code-2-2","id":"setup-code-2-2","data":{"htmlAttributes":{"data-node-index":8}}}],"position":{"start":{"line":20,"column":1},"end":{"line":20,"column":9},"indent":[]},"index":6,"data":{"htmlName":"section","htmlAttributes":{"class":"depth-2 sections","id":"setup","data-node-index":6}},"id":"setup","value":"Setup","parentId":"document-structuring"},{"type":"paragraph","children":[{"type":"text","value":"To test the structuring of a document we will use this document as an example.","position":{"start":{"line":22,"column":1},"end":{"line":22,"column":79},"indent":[]}}],"position":{"start":{"line":22,"column":1},"end":{"line":22,"column":79},"indent":[]},"index":7,"depth":2,"parentId":"setup","childIndex":0,"childId":"p-2-1","id":"setup-p-2-1","data":{"htmlAttributes":{"data-node-index":7}}},{"type":"code","lang":"javascript","value":"var document = project.documents.at('testcases/structure-spec')","position":{"start":{"line":24,"column":1},"end":{"line":26,"column":4},"indent":[1,1]},"index":8,"depth":2,"parentId":"setup","childIndex":1,"childId":"code-2-2","id":"setup-code-2-2","data":{"htmlAttributes":{"data-node-index":8}}},{"type":"section","depth":2,"children":[{"type":"heading","depth":2,"children":[{"type":"text","value":"Specifications","position":{"start":{"line":28,"column":4},"end":{"line":28,"column":18},"indent":[]}}],"position":{"start":{"line":28,"column":1},"end":{"line":28,"column":18},"indent":[]},"index":9,"data":{"htmlAttributes":{"id":"specifications"}},"id":"specifications","value":"Specifications","parentId":"document-structuring"},{"type":"article","depth":3,"children":[{"type":"heading","depth":3,"children":[{"type":"text","value":"Documents treat h2 as section headings","position":{"start":{"line":30,"column":5},"end":{"line":30,"column":43},"indent":[]}}],"position":{"start":{"line":30,"column":1},"end":{"line":30,"column":44},"indent":[]},"index":10,"data":{"htmlAttributes":{"id":"documents-treat-h2-as-section-headings"}},"id":"documents-treat-h2-as-section-headings","value":"Documents treat h2 as section headings","parentId":"specifications"},{"type":"code","lang":"javascript","value":"var sections = document.headings.sections\n\nsections.should.containEql('Setup','Specifications')\nsections.should.not.containEql('Article Heading B')","position":{"start":{"line":32,"column":1},"end":{"line":37,"column":4},"indent":[1,1,1,1,1]},"index":11,"depth":3,"parentId":"documents-treat-h2-as-section-headings","childIndex":0,"childId":"code-3-1","id":"documents-treat-h2-as-section-headings-code-3-1","data":{"htmlAttributes":{"data-node-index":11}}}],"position":{"start":{"line":30,"column":1},"end":{"line":30,"column":44},"indent":[]},"index":10,"data":{"htmlName":"article","htmlAttributes":{"class":"depth-3 articles","id":"documents-treat-h2-as-section-headings","data-node-index":10}},"id":"documents-treat-h2-as-section-headings","value":"Documents treat h2 as section headings","parentId":"specifications"},{"type":"article","depth":3,"children":[{"type":"heading","depth":3,"children":[{"type":"text","value":"Documents treat h3 as article headings","position":{"start":{"line":39,"column":5},"end":{"line":39,"column":43},"indent":[]}}],"position":{"start":{"line":39,"column":1},"end":{"line":39,"column":44},"indent":[]},"index":12,"data":{"htmlAttributes":{"id":"documents-treat-h3-as-article-headings"}},"id":"documents-treat-h3-as-article-headings","value":"Documents treat h3 as article headings","parentId":"specifications"},{"type":"code","lang":"javascript","value":"var articles = document.headings.articles\n\narticles.should.not.containEql('Setup','Specifications')\narticles.should.containEql('Article Heading B')","position":{"start":{"line":41,"column":1},"end":{"line":46,"column":4},"indent":[1,1,1,1,1]},"index":13,"depth":3,"parentId":"documents-treat-h3-as-article-headings","childIndex":0,"childId":"code-3-1","id":"documents-treat-h3-as-article-headings-code-3-1","data":{"htmlAttributes":{"data-node-index":13}}}],"position":{"start":{"line":39,"column":1},"end":{"line":39,"column":44},"indent":[]},"index":12,"data":{"htmlName":"article","htmlAttributes":{"class":"depth-3 articles","id":"documents-treat-h3-as-article-headings","data-node-index":12}},"id":"documents-treat-h3-as-article-headings","value":"Documents treat h3 as article headings","parentId":"specifications"},{"type":"article","depth":3,"children":[{"type":"heading","depth":3,"children":[{"type":"text","value":"Sections can be mapped back to their markdown line numbers","position":{"start":{"line":48,"column":5},"end":{"line":48,"column":63},"indent":[]}}],"position":{"start":{"line":48,"column":1},"end":{"line":48,"column":63},"indent":[]},"index":14,"data":{"htmlAttributes":{"id":"sections-can-be-mapped-back-to-their-markdown-line-numbers"}},"id":"sections-can-be-mapped-back-to-their-markdown-line-numbers","value":"Sections can be mapped back to their markdown line numbers","parentId":"specifications"},{"type":"code","lang":"javascript","value":"document.sections.setup.beginsAt.should.have.property('line', 14)\ndocument.sections.setup.lines.should.have.property('length', 9)","position":{"start":{"line":50,"column":1},"end":{"line":53,"column":4},"indent":[1,1,1]},"index":15,"depth":3,"parentId":"sections-can-be-mapped-back-to-their-markdown-line-numbers","childIndex":0,"childId":"code-3-1","id":"sections-can-be-mapped-back-to-their-markdown-line-numbers-code-3-1","data":{"htmlAttributes":{"data-node-index":15}}}],"position":{"start":{"line":48,"column":1},"end":{"line":48,"column":63},"indent":[]},"index":14,"data":{"htmlName":"article","htmlAttributes":{"class":"depth-3 articles","id":"sections-can-be-mapped-back-to-their-markdown-line-numbers","data-node-index":14}},"id":"sections-can-be-mapped-back-to-their-markdown-line-numbers","value":"Sections can be mapped back to their markdown line numbers","parentId":"specifications"},{"type":"article","depth":3,"children":[{"type":"heading","depth":3,"children":[{"type":"text","value":"Sections reference their parent sections","position":{"start":{"line":55,"column":5},"end":{"line":55,"column":45},"indent":[]}}],"position":{"start":{"line":55,"column":1},"end":{"line":55,"column":45},"indent":[]},"index":16,"data":{"htmlAttributes":{"id":"sections-reference-their-parent-sections"}},"id":"sections-reference-their-parent-sections","value":"Sections reference their parent sections","parentId":"specifications"},{"type":"div","depth":4,"children":[{"type":"heading","depth":4,"children":[{"type":"text","value":"For Example","position":{"start":{"line":57,"column":6},"end":{"line":57,"column":17},"indent":[]}}],"position":{"start":{"line":57,"column":1},"end":{"line":57,"column":17},"indent":[]},"index":17,"data":{"htmlAttributes":{"id":"for-example"}},"id":"for-example","value":"For Example","parentId":"sections-reference-their-parent-sections"},{"type":"code","lang":"javascript","value":"document.nodes.at('for-example').parent.should.have.property('lineNumber', 44)","position":{"start":{"line":59,"column":1},"end":{"line":61,"column":4},"indent":[1,1]},"index":18,"depth":4,"parentId":"for-example","childIndex":0,"childId":"code-4-1","id":"for-example-code-4-1","data":{"htmlAttributes":{"data-node-index":18}}}],"position":{"start":{"line":57,"column":1},"end":{"line":57,"column":17},"indent":[]},"index":17,"data":{"htmlName":"div","htmlAttributes":{"class":"depth-4","id":"for-example","data-node-index":17}},"id":"for-example","value":"For Example","parentId":"sections-reference-their-parent-sections"}],"position":{"start":{"line":55,"column":1},"end":{"line":55,"column":45},"indent":[]},"index":16,"data":{"htmlName":"article","htmlAttributes":{"class":"depth-3 articles","id":"sections-reference-their-parent-sections","data-node-index":16}},"id":"sections-reference-their-parent-sections","value":"Sections reference their parent sections","parentId":"specifications"},{"type":"article","depth":3,"children":[{"type":"heading","depth":3,"children":[{"type":"text","value":"Documents provide an easy way of accessing their sections","position":{"start":{"line":63,"column":5},"end":{"line":63,"column":62},"indent":[]}}],"position":{"start":{"line":63,"column":1},"end":{"line":63,"column":62},"indent":[]},"index":19,"data":{"htmlAttributes":{"id":"documents-provide-an-easy-way-of-accessing-their-sections"}},"id":"documents-provide-an-easy-way-of-accessing-their-sections","value":"Documents provide an easy way of accessing their sections","parentId":"specifications"}],"position":{"start":{"line":63,"column":1},"end":{"line":63,"column":62},"indent":[]},"index":19,"data":{"htmlName":"article","htmlAttributes":{"class":"depth-3 articles","id":"documents-provide-an-easy-way-of-accessing-their-sections","data-node-index":19}},"id":"documents-provide-an-easy-way-of-accessing-their-sections","value":"Documents provide an easy way of accessing their sections","parentId":"specifications"}],"position":{"start":{"line":28,"column":1},"end":{"line":28,"column":18},"indent":[]},"index":9,"data":{"htmlName":"section","htmlAttributes":{"class":"depth-2 sections","id":"specifications","data-node-index":9}},"id":"specifications","value":"Specifications","parentId":"document-structuring"},{"type":"article","depth":3,"children":[{"type":"heading","depth":3,"children":[{"type":"text","value":"Documents treat h2 as section headings","position":{"start":{"line":30,"column":5},"end":{"line":30,"column":43},"indent":[]}}],"position":{"start":{"line":30,"column":1},"end":{"line":30,"column":44},"indent":[]},"index":10,"data":{"htmlAttributes":{"id":"documents-treat-h2-as-section-headings"}},"id":"documents-treat-h2-as-section-headings","value":"Documents treat h2 as section headings","parentId":"specifications"},{"type":"code","lang":"javascript","value":"var sections = document.headings.sections\n\nsections.should.containEql('Setup','Specifications')\nsections.should.not.containEql('Article Heading B')","position":{"start":{"line":32,"column":1},"end":{"line":37,"column":4},"indent":[1,1,1,1,1]},"index":11,"depth":3,"parentId":"documents-treat-h2-as-section-headings","childIndex":0,"childId":"code-3-1","id":"documents-treat-h2-as-section-headings-code-3-1","data":{"htmlAttributes":{"data-node-index":11}}}],"position":{"start":{"line":30,"column":1},"end":{"line":30,"column":44},"indent":[]},"index":10,"data":{"htmlName":"article","htmlAttributes":{"class":"depth-3 articles","id":"documents-treat-h2-as-section-headings","data-node-index":10}},"id":"documents-treat-h2-as-section-headings","value":"Documents treat h2 as section headings","parentId":"specifications"},{"type":"code","lang":"javascript","value":"var sections = document.headings.sections\n\nsections.should.containEql('Setup','Specifications')\nsections.should.not.containEql('Article Heading B')","position":{"start":{"line":32,"column":1},"end":{"line":37,"column":4},"indent":[1,1,1,1,1]},"index":11,"depth":3,"parentId":"documents-treat-h2-as-section-headings","childIndex":0,"childId":"code-3-1","id":"documents-treat-h2-as-section-headings-code-3-1","data":{"htmlAttributes":{"data-node-index":11}}},{"type":"article","depth":3,"children":[{"type":"heading","depth":3,"children":[{"type":"text","value":"Documents treat h3 as article headings","position":{"start":{"line":39,"column":5},"end":{"line":39,"column":43},"indent":[]}}],"position":{"start":{"line":39,"column":1},"end":{"line":39,"column":44},"indent":[]},"index":12,"data":{"htmlAttributes":{"id":"documents-treat-h3-as-article-headings"}},"id":"documents-treat-h3-as-article-headings","value":"Documents treat h3 as article headings","parentId":"specifications"},{"type":"code","lang":"javascript","value":"var articles = document.headings.articles\n\narticles.should.not.containEql('Setup','Specifications')\narticles.should.containEql('Article Heading B')","position":{"start":{"line":41,"column":1},"end":{"line":46,"column":4},"indent":[1,1,1,1,1]},"index":13,"depth":3,"parentId":"documents-treat-h3-as-article-headings","childIndex":0,"childId":"code-3-1","id":"documents-treat-h3-as-article-headings-code-3-1","data":{"htmlAttributes":{"data-node-index":13}}}],"position":{"start":{"line":39,"column":1},"end":{"line":39,"column":44},"indent":[]},"index":12,"data":{"htmlName":"article","htmlAttributes":{"class":"depth-3 articles","id":"documents-treat-h3-as-article-headings","data-node-index":12}},"id":"documents-treat-h3-as-article-headings","value":"Documents treat h3 as article headings","parentId":"specifications"},{"type":"code","lang":"javascript","value":"var articles = document.headings.articles\n\narticles.should.not.containEql('Setup','Specifications')\narticles.should.containEql('Article Heading B')","position":{"start":{"line":41,"column":1},"end":{"line":46,"column":4},"indent":[1,1,1,1,1]},"index":13,"depth":3,"parentId":"documents-treat-h3-as-article-headings","childIndex":0,"childId":"code-3-1","id":"documents-treat-h3-as-article-headings-code-3-1","data":{"htmlAttributes":{"data-node-index":13}}},{"type":"article","depth":3,"children":[{"type":"heading","depth":3,"children":[{"type":"text","value":"Sections can be mapped back to their markdown line numbers","position":{"start":{"line":48,"column":5},"end":{"line":48,"column":63},"indent":[]}}],"position":{"start":{"line":48,"column":1},"end":{"line":48,"column":63},"indent":[]},"index":14,"data":{"htmlAttributes":{"id":"sections-can-be-mapped-back-to-their-markdown-line-numbers"}},"id":"sections-can-be-mapped-back-to-their-markdown-line-numbers","value":"Sections can be mapped back to their markdown line numbers","parentId":"specifications"},{"type":"code","lang":"javascript","value":"document.sections.setup.beginsAt.should.have.property('line', 14)\ndocument.sections.setup.lines.should.have.property('length', 9)","position":{"start":{"line":50,"column":1},"end":{"line":53,"column":4},"indent":[1,1,1]},"index":15,"depth":3,"parentId":"sections-can-be-mapped-back-to-their-markdown-line-numbers","childIndex":0,"childId":"code-3-1","id":"sections-can-be-mapped-back-to-their-markdown-line-numbers-code-3-1","data":{"htmlAttributes":{"data-node-index":15}}}],"position":{"start":{"line":48,"column":1},"end":{"line":48,"column":63},"indent":[]},"index":14,"data":{"htmlName":"article","htmlAttributes":{"class":"depth-3 articles","id":"sections-can-be-mapped-back-to-their-markdown-line-numbers","data-node-index":14}},"id":"sections-can-be-mapped-back-to-their-markdown-line-numbers","value":"Sections can be mapped back to their markdown line numbers","parentId":"specifications"},{"type":"code","lang":"javascript","value":"document.sections.setup.beginsAt.should.have.property('line', 14)\ndocument.sections.setup.lines.should.have.property('length', 9)","position":{"start":{"line":50,"column":1},"end":{"line":53,"column":4},"indent":[1,1,1]},"index":15,"depth":3,"parentId":"sections-can-be-mapped-back-to-their-markdown-line-numbers","childIndex":0,"childId":"code-3-1","id":"sections-can-be-mapped-back-to-their-markdown-line-numbers-code-3-1","data":{"htmlAttributes":{"data-node-index":15}}},{"type":"article","depth":3,"children":[{"type":"heading","depth":3,"children":[{"type":"text","value":"Sections reference their parent sections","position":{"start":{"line":55,"column":5},"end":{"line":55,"column":45},"indent":[]}}],"position":{"start":{"line":55,"column":1},"end":{"line":55,"column":45},"indent":[]},"index":16,"data":{"htmlAttributes":{"id":"sections-reference-their-parent-sections"}},"id":"sections-reference-their-parent-sections","value":"Sections reference their parent sections","parentId":"specifications"},{"type":"div","depth":4,"children":[{"type":"heading","depth":4,"children":[{"type":"text","value":"For Example","position":{"start":{"line":57,"column":6},"end":{"line":57,"column":17},"indent":[]}}],"position":{"start":{"line":57,"column":1},"end":{"line":57,"column":17},"indent":[]},"index":17,"data":{"htmlAttributes":{"id":"for-example"}},"id":"for-example","value":"For Example","parentId":"sections-reference-their-parent-sections"},{"type":"code","lang":"javascript","value":"document.nodes.at('for-example').parent.should.have.property('lineNumber', 44)","position":{"start":{"line":59,"column":1},"end":{"line":61,"column":4},"indent":[1,1]},"index":18,"depth":4,"parentId":"for-example","childIndex":0,"childId":"code-4-1","id":"for-example-code-4-1","data":{"htmlAttributes":{"data-node-index":18}}}],"position":{"start":{"line":57,"column":1},"end":{"line":57,"column":17},"indent":[]},"index":17,"data":{"htmlName":"div","htmlAttributes":{"class":"depth-4","id":"for-example","data-node-index":17}},"id":"for-example","value":"For Example","parentId":"sections-reference-their-parent-sections"}],"position":{"start":{"line":55,"column":1},"end":{"line":55,"column":45},"indent":[]},"index":16,"data":{"htmlName":"article","htmlAttributes":{"class":"depth-3 articles","id":"sections-reference-their-parent-sections","data-node-index":16}},"id":"sections-reference-their-parent-sections","value":"Sections reference their parent sections","parentId":"specifications"},{"type":"div","depth":4,"children":[{"type":"heading","depth":4,"children":[{"type":"text","value":"For Example","position":{"start":{"line":57,"column":6},"end":{"line":57,"column":17},"indent":[]}}],"position":{"start":{"line":57,"column":1},"end":{"line":57,"column":17},"indent":[]},"index":17,"data":{"htmlAttributes":{"id":"for-example"}},"id":"for-example","value":"For Example","parentId":"sections-reference-their-parent-sections"},{"type":"code","lang":"javascript","value":"document.nodes.at('for-example').parent.should.have.property('lineNumber', 44)","position":{"start":{"line":59,"column":1},"end":{"line":61,"column":4},"indent":[1,1]},"index":18,"depth":4,"parentId":"for-example","childIndex":0,"childId":"code-4-1","id":"for-example-code-4-1","data":{"htmlAttributes":{"data-node-index":18}}}],"position":{"start":{"line":57,"column":1},"end":{"line":57,"column":17},"indent":[]},"index":17,"data":{"htmlName":"div","htmlAttributes":{"class":"depth-4","id":"for-example","data-node-index":17}},"id":"for-example","value":"For Example","parentId":"sections-reference-their-parent-sections"},{"type":"code","lang":"javascript","value":"document.nodes.at('for-example').parent.should.have.property('lineNumber', 44)","position":{"start":{"line":59,"column":1},"end":{"line":61,"column":4},"indent":[1,1]},"index":18,"depth":4,"parentId":"for-example","childIndex":0,"childId":"code-4-1","id":"for-example-code-4-1","data":{"htmlAttributes":{"data-node-index":18}}},{"type":"article","depth":3,"children":[{"type":"heading","depth":3,"children":[{"type":"text","value":"Documents provide an easy way of accessing their sections","position":{"start":{"line":63,"column":5},"end":{"line":63,"column":62},"indent":[]}}],"position":{"start":{"line":63,"column":1},"end":{"line":63,"column":62},"indent":[]},"index":19,"data":{"htmlAttributes":{"id":"documents-provide-an-easy-way-of-accessing-their-sections"}},"id":"documents-provide-an-easy-way-of-accessing-their-sections","value":"Documents provide an easy way of accessing their sections","parentId":"specifications"}],"position":{"start":{"line":63,"column":1},"end":{"line":63,"column":62},"indent":[]},"index":19,"data":{"htmlName":"article","htmlAttributes":{"class":"depth-3 articles","id":"documents-provide-an-easy-way-of-accessing-their-sections","data-node-index":19}},"id":"documents-provide-an-easy-way-of-accessing-their-sections","value":"Documents provide an easy way of accessing their sections","parentId":"specifications"},{"type":"section","depth":2,"children":[{"type":"heading","depth":2,"children":[{"type":"text","value":"Usage","position":{"start":{"line":65,"column":4},"end":{"line":65,"column":9},"indent":[]}}],"position":{"start":{"line":65,"column":1},"end":{"line":65,"column":10},"indent":[]},"index":20,"data":{"htmlAttributes":{"id":"usage"}},"id":"usage","value":"Usage","parentId":"document-structuring"},{"type":"paragraph","children":[{"type":"text","value":"How you use this feature is up to you.","position":{"start":{"line":67,"column":1},"end":{"line":67,"column":39},"indent":[]}}],"position":{"start":{"line":67,"column":1},"end":{"line":67,"column":39},"indent":[]},"index":21,"depth":2,"parentId":"usage","childIndex":0,"childId":"p-2-1","id":"usage-p-2-1","data":{"htmlAttributes":{"data-node-index":21}}}],"position":{"start":{"line":65,"column":1},"end":{"line":65,"column":10},"indent":[]},"index":20,"data":{"htmlName":"section","htmlAttributes":{"class":"depth-2 sections","id":"usage","data-node-index":20}},"id":"usage","value":"Usage","parentId":"document-structuring"},{"type":"paragraph","children":[{"type":"text","value":"How you use this feature is up to you.","position":{"start":{"line":67,"column":1},"end":{"line":67,"column":39},"indent":[]}}],"position":{"start":{"line":67,"column":1},"end":{"line":67,"column":39},"indent":[]},"index":21,"depth":2,"parentId":"usage","childIndex":0,"childId":"p-2-1","id":"usage-p-2-1","data":{"htmlAttributes":{"data-node-index":21}}}],"position":{"start":{"line":1,"column":1},"end":{"line":68,"column":1}}},"indexes":{"ids":{"testcases__structure-spec-yaml-1-1":0,"testcases__structure-spec-p-1-2":1,"testcases__structure-spec-list-1-3":2,"document-structuring":3,"document-structuring-p-1-1":4,"document-structuring-p-1-2":5,"setup":6,"setup-p-2-1":7,"setup-code-2-2":8,"specifications":9,"documents-treat-h2-as-section-headings":10,"documents-treat-h2-as-section-headings-code-3-1":11,"documents-treat-h3-as-article-headings":12,"documents-treat-h3-as-article-headings-code-3-1":13,"sections-can-be-mapped-back-to-their-markdown-line-numbers":14,"sections-can-be-mapped-back-to-their-markdown-line-numbers-code-3-1":15,"sections-reference-their-parent-sections":16,"for-example":17,"for-example-code-4-1":18,"documents-provide-an-easy-way-of-accessing-their-sections":19,"usage":20,"usage-p-2-1":21},"depths":{"1":[3],"2":[6,9,20],"3":[10,12,14,16,19],"4":[17],"5":[],"6":[]},"types":{"yaml":[0],"paragraph":[1,4,5,7,21],"list":[2],"heading":[3,6,9,10,12,14,16,17,19,20],"code":[8,11,13,15,18]},"childrenIndexes":{"testcases__structure-spec":[0,1,2,3],"document-structuring":[4,5,6,9,20],"setup":[7,8],"specifications":[10,12,14,16,19],"documents-treat-h2-as-section-headings":[11],"documents-treat-h3-as-article-headings":[13],"sections-can-be-mapped-back-to-their-markdown-line-numbers":[15],"sections-reference-their-parent-sections":[17],"for-example":[18],"usage":[21]}},"html":"<main id=\"testcases__structure-spec\" class=\"skypager-document testcases\"><p data-node-index=\"1\">This is a paragraph. I wanna see what happens when the first item isn&apos;t a title heading.</p><ul data-node-index=\"2\">\n<li>list item one</li>\n<li>list item two</li>\n</ul><h1 id=\"document-structuring\" data-node-index=\"3\">Document Structuring</h1><p data-node-index=\"4\">Skypager allows you to provide special meaning to the content of a\ndocument by including it under document headings.  Heading hierarchies\ncan be used by An Entity Model to build object trees, for example the\ndocument you are reading now has an <code>h2</code> specifications section that is\na required section for.</p><p data-node-index=\"5\"><a href=\"Link%20Body%20Text\">link:docs/assets/data-source-spec</a></p><section class=\"depth-2 sections\" id=\"setup\" data-node-index=\"6\"><h2 id=\"setup\">Setup</h2><p data-node-index=\"7\">To test the structuring of a document we will use this document as an example.</p><pre><code data-node-index=\"8\">var document = project.documents.at(&apos;testcases/structure-spec&apos;)\n</code></pre></section><section class=\"depth-2 sections\" id=\"specifications\" data-node-index=\"9\"><h2 id=\"specifications\">Specifications</h2><article class=\"depth-3 articles\" id=\"documents-treat-h2-as-section-headings\" data-node-index=\"10\"><h3 id=\"documents-treat-h2-as-section-headings\">Documents treat h2 as section headings</h3><pre><code data-node-index=\"11\">var sections = document.headings.sections\n\nsections.should.containEql(&apos;Setup&apos;,&apos;Specifications&apos;)\nsections.should.not.containEql(&apos;Article Heading B&apos;)\n</code></pre></article><article class=\"depth-3 articles\" id=\"documents-treat-h3-as-article-headings\" data-node-index=\"12\"><h3 id=\"documents-treat-h3-as-article-headings\">Documents treat h3 as article headings</h3><pre><code data-node-index=\"13\">var articles = document.headings.articles\n\narticles.should.not.containEql(&apos;Setup&apos;,&apos;Specifications&apos;)\narticles.should.containEql(&apos;Article Heading B&apos;)\n</code></pre></article><article class=\"depth-3 articles\" id=\"sections-can-be-mapped-back-to-their-markdown-line-numbers\" data-node-index=\"14\"><h3 id=\"sections-can-be-mapped-back-to-their-markdown-line-numbers\">Sections can be mapped back to their markdown line numbers</h3><pre><code data-node-index=\"15\">document.sections.setup.beginsAt.should.have.property(&apos;line&apos;, 14)\ndocument.sections.setup.lines.should.have.property(&apos;length&apos;, 9)\n</code></pre></article><article class=\"depth-3 articles\" id=\"sections-reference-their-parent-sections\" data-node-index=\"16\"><h3 id=\"sections-reference-their-parent-sections\">Sections reference their parent sections</h3><div class=\"depth-4\" id=\"for-example\" data-node-index=\"17\"><h4 id=\"for-example\">For Example</h4><pre><code data-node-index=\"18\">document.nodes.at(&apos;for-example&apos;).parent.should.have.property(&apos;lineNumber&apos;, 44)\n</code></pre></div></article><article class=\"depth-3 articles\" id=\"documents-provide-an-easy-way-of-accessing-their-sections\" data-node-index=\"19\"><h3 id=\"documents-provide-an-easy-way-of-accessing-their-sections\">Documents provide an easy way of accessing their sections</h3></article></section><section class=\"depth-2 sections\" id=\"usage\" data-node-index=\"20\"><h2 id=\"usage\">Usage</h2><p data-node-index=\"21\">How you use this feature is up to you.</p></section></main>\n"};